
/*
    Element Controller
    =======================================
    
    
    Created         2014-03-12 08:59:26
    namespace       com.wtc.controller
    Requirements    null
    Description     General element controller
    -05-05 16:51:10
    Version         0.1
 */

(function() {
  var appNS, base;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  window[appNS] || (window[appNS] = {});

  (base = window[appNS]).controller || (base.controller = {});

  (function($, NS) {
    return NS.ElementController = (function() {
      function ElementController($element) {
        this.$element = $element;
        this.$element.data('controller', this);
        this.$element.data('instanciated', true);
      }

      ElementController.prototype.elementExistsInDOM = function() {
        var element, exists;
        exists = this.$element && this.$element[0];
        if (!exists) {
          return false;
        }
        element = this.$element[0];
        while (element) {
          if (element === document) {
            return true;
          }
          element = element.parentNode;
        }
        return false;
      };

      return ElementController;

    })();
  })(jQuery, window[appNS].controller);

}).call(this);


/*
    $.ExecuteControllers
    =======================================
    
    
    Created         2014-03-11 17:07:58
    namespace       jquery
    Requirements    jquery
    Description     This is a JQ plugin that goes through and finds all elements with a named controller and initialises it.
    -06-10 11:17:20
    Version         0.5
 */

(function() {
  window.game || (window.game = {});

  (function($) {
    return $.fn.ExecuteControllers = function() {
      var els, instanciate, objreturn;
      els = this.find('[data-controller]');
      instanciate = function(data, controller, ns, $op) {
        if (typeof ns[controller] === 'function') {
          data.instance = new ns[controller]($op);
          data.initialised = 'yes';
          return data.instance;
        } else {
          throw new Error("The controller " + controller + " does not exist at namespace " + data.namespace);
        }
      };
      objreturn = $();
      els.each(function() {
        var $op, _ns, controller, data, e, ns;
        $op = $(this);
        data = $op.data();
        if (data.initialised) {
          return;
        }
        ns = data.namespace || (data.namespace = '');
        _ns = ns;
        controller = data.controller;
        ns = (function(address) {
          var baseAddress, i, j, len, obj;
          baseAddress = window;
          for (i = j = 0, len = address.length; j < len; i = ++j) {
            obj = address[i];
            if (typeof address[i] === 'function') {
              continue;
            }
            if (typeof baseAddress[address[i]] === "object") {
              baseAddress = baseAddress[address[i]];
            } else {
              return window;
            }
          }
          return baseAddress;
        })(ns.split('.'));
        objreturn = objreturn.add($op);
        try {
          instanciate(data, controller, ns, $op);
        } catch (error) {
          e = error;
          console.warn("Error: " + e.message + ". For " + _ns + "." + controller + " ");
        }
        return $op.data().controller;
      });
      return objreturn;
    };
  })(jQuery);

}).call(this);

this["GameApplication"] = this["GameApplication"] || {};
this["GameApplication"]["templates"] = this["GameApplication"]["templates"] || {};
this["GameApplication"]["templates"]["application"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_application\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-application scene-background\">\n  <div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_canvas\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-application-canvas\"><div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-canvas-bg\"></div></div>\n  <div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_controls\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-application-controls\"></div>  \n</div>\n";
},"useData":true});
this["GameApplication"]["templates"]["choosekingdom"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_choosekingdom\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-choosekingdom screen-wrapper\">\n  <h2>Choose your location</h2>\n  <div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-kingdom-list\">\n    <div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-kingdom-list__kingdom\" data-index=\"1\" data-kingdom=\"city\"></div>\n    <div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-kingdom-list__kingdom\" data-index=\"2\" data-kingdom=\"falls\"></div>\n    <div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-kingdom-list__kingdom\" data-index=\"3\" data-kingdom=\"tostarena\"></div>\n    <div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-kingdom-list__kingdom\" data-index=\"4\" data-kingdom=\"gardens\"></div>\n    <div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-kingdom-list__kingdom\" data-index=\"5\" data-kingdom=\"bonneton\"></div>\n    <div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-kingdom-list__kingdom\" data-index=\"6\" data-kingdom=\"volbono\"></div>\n  </div>\n</div>\n";
},"useData":true});
this["GameApplication"]["templates"]["interface_addheadshot"] = Handlebars.partials = Handlebars.template({"1":function(container,depth0,helpers,partials,data) {
    var helper;

  return "        <button id=\""
    + container.escapeExpression(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : helpers.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_useWebcam\" class=\"interface-button interface-webcam button button--white\">\n          <span>Camera</span>\n        </button>\n";
},"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var stack1, helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_interface_addheadshot\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-add-headshot screen-wrapper\">\n  <h2>Add yourself</h2>\n  <div class=\"interface_buttons\">\n    <div class=\"interface_buttons_left\">\n      <button class=\"interface-restart button--filler\"><span class=\"interface-restart__button button button--orange button--small button--icon button--icon--restart\"><span>Start over</span></span><span class=\"interface-restart__txt\">Start over</span></button>\n    </div>\n    <div class=\"interface_buttons-centered\">\n      <button class=\"button button--red button--icon button--icon--back button--medium-fliptext interface-back back\">\n        <span>Back</span>\n      </button>\n      <button class=\"interface-button interface-upload button button--white\">\n        <span>Upload</span>\n      </button>\n"
    + ((stack1 = helpers["if"].call(alias1,(depth0 != null ? depth0.hasCamera : depth0),{"name":"if","hash":{},"fn":container.program(1, data, 0),"inverse":container.noop,"data":data})) != null ? stack1 : "")
    + "      <div class=\"interface-restart interface-restart-mobile\">\n        <button class=\"button button--medium-fliptext button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n      </div>\n    </div>\n    <div class=\"interface_buttons_right\">\n      <div class=\"interface-restart interface-restart__button\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n        <span>Start over</span>\n      </div>\n    </span>\n  </div>\n</div>\n";
},"useData":true});
this["GameApplication"]["templates"]["interface_additems"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_interface_additems\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-additems screen-wrapper interface-additems\">\n  <h2>Customize!</h2>\n  <div class=\"interface_buttons\">\n    <div class=\"interface_buttons_left\">\n      <div class=\"interface_button_wrapper interface_button_sides\">\n        <div class=\"button-tab button-tab--backgrounds button-tab--left\">\n          <div class=\"button-tab__bg\"></div>\n          <button class=\"button button--gold button--icon button--icon--up list-nav list-nav--up\"><span>Up</span></button>\n          <div class=\"button-tab__buttons\">\n            <ul>\n              <li><button class=\"button_deco button_deco_1 button_border button_border_1\"><span>1</span></button></li>\n              <li><button class=\"button_deco button_deco_2 button_border button_border_2\"><span>2</span></button></li>\n              <li><button class=\"button_deco button_deco_3 button_border button_border_3\"><span>3</span></button></li>\n              <li><button class=\"button_deco button_deco_4 button_border button_border_4\"><span>4</span></button></li>\n              <li><button class=\"button_deco button_deco_5 button_border button_border_5\"><span>5</span></button></li>\n              <li><button class=\"button_deco button_deco_6 button_border button_border_6\"><span>6</span></button></li>\n              <li><button class=\"button_deco button_deco_7 button_border button_border_7\"><span>7</span></button></li>\n              <li><button class=\"button_deco button_deco_8 button_background button_background_1\"><span>1</span></button></li>\n              <li><button class=\"button_deco button_deco_9 button_background button_background_2\"><span>2</span></button></li>\n              <li><button class=\"button_deco button_deco_10 button_background button_background_3\"><span>3</span></button></li>\n              <li><button class=\"button_deco button_deco_11 button_background button_background_4\"><span>4</span></button></li>\n              <li><button class=\"button_deco button_deco_12 button_background button_background_5\"><span>5</span></button></li>\n              <li><button class=\"button_deco button_deco_13 button_background button_background_6\"><span>6</span></button></li>\n            </ul>\n          </div>\n          <button class=\"button button--gold button--icon button--icon--down list-nav list-nav--down\"><span>Down</span></button>\n        </div>\n      </div>\n      <div class=\"interface-addcard interface-addcard-desktop\">\n        <button class=\"interface-addcard__button button button--gold button--icon button--icon--plus1\">\n          <span>+1</span>\n        </button>\n        <span>Add a friend</span>\n      </div>\n      <div class=\"interface_button_wrapper interface_button_wrapper-mobile\">\n        <button id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_item-toggler\" class=\"button button--black button--small interface-item-toggler\"><span>Hide menus &lt;</span></button>\n        <div class=\"button-tab button-tab--mobile\">\n          <div class=\"button-tab__bg\"></div>\n          <div class=\"button-tab__buttons\">\n            <div class=\"interface-addcard\">\n              <button class=\"interface-addcard__button button button--gold button--icon button--icon--plus1\">\n                <span>+1</span>\n              </button>\n              <span>Add a friend</span>\n            </div>\n            <button class=\"button interface-add-background\">\n              <span>Background</span>\n            </button>\n            <button class=\"button interface-add-sticker\">\n              <span>Characters</span>\n            </button>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"interface_buttons-centered\">\n      <button class=\"button button--red interface-back\">\n        <span>Back</span>\n      </button>\n      <button class=\"button button--white interface-download\">        \n        <span>Download</span>\n      </button>\n      <button class=\"button button--white interface-save-image\">\n        <span>Save image</span>\n      </button>\n      <div class=\"interface-restart interface-restart-mobile\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n      </div>\n    </div>\n    <div class=\"interface_buttons_right\">\n      <div class=\"interface_button_wrapper interface_button_sides\">\n        <div class=\"button-tab button-tab--stickers\">\n          <div class=\"button-tab__bg\"></div>\n          <button class=\"button button--gold button--icon button--icon--up list-nav list-nav--up\"><span>Up</span></button>\n          <div class=\"button-tab__buttons\">\n            <ul>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_1\">1</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_2\">2</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_13\">13</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_3\">3</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_4\">4</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_5\">5</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_6\">6</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_7\">7</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_8\">8</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_9\">9</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_10\">10</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_11\">11</button></li>\n              <li><button draggable=\"true\" class=\"button_sticker button_sticker_12\">12</button></li>\n            </ul>\n          </div>\n          <button class=\"button button--gold button--icon button--icon--down list-nav list-nav--down\"><span>Down</span></button>\n        </div>\n      </div>\n      <div class=\"interface-restart interface-restart__button\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n        <span>Start over</span>\n      </div>\n    </div>\n  </div>\n</div>\n";
},"useData":true});
this["GameApplication"]["templates"]["interface_crop"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_interface_crop\" class=\"screen-wrapper "
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-crop interface-crop\">\n  <h2 class=\"with-highlight\">Trim out your photo</h2>\n  <p>Paint the areas of the photo you want to keep - use the eraser for any mistakes!</p>\n  <div class=\"interface_buttons\">\n    <div class=\"interface_buttons_left\">\n      <button class=\"interface-restart button--filler\"><span class=\"interface-restart__button button button--orange button--small button--icon button--icon--restart\"><span>Start over</span></span><span class=\"interface-restart__txt\">Start over</span></button>\n    </div>\n    <div class=\"interface_buttons-centered\">\n      <button id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_back\" class=\"button button--red interface-back\">\n        <span>Back</span>\n      </button>\n      <button id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-ready\" class=\"button button--white interface-add\">\n        <span>Next</span>\n      </button>\n      <div class=\"interface-restart interface-restart-mobile\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n      </div>\n    </div>\n    <div class=\"interface_buttons_right interface_buttons_crop\">\n      <div class=\"button-wrapper interface_button_sides\">\n        <div class=\"button-tab\">\n          <div class=\"button-tab__bg\"></div>\n          <div class=\"button-tab__buttons\">\n            <div class=\"button-group crop-edits-mode crop-edits-toggle\">\n              <h4>Mode - paint</h4>\n              <input type=\"checkbox\" name=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-mode\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-mode\" class=\"crop-mode-input\" checked />\n              <div class=\"crop-mode\">\n                <label for=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-mode\" class=\"crop-mode__label crop-mode__label-fill\"><span>Fill</span></label>\n                <label for=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-mode\" class=\"crop-mode__label crop-mode__label-erase\"><span>Erase</span></label>\n              </div>\n            </div>\n            <div class=\"button-group crop-edits-brush crop-edits-toggle\">\n              <h4>Brush Size</h4>\n              <div class=\"crop-brush\">\n                <label for=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_brush-preview\" class=\"crop-brush-preview\"><div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-brush\"></div></label>\n                <input type=\"checkbox\" name=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_brush-preview\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_brush-preview\" class=\"crop-brush-input\" />\n                <div class=\"crop-brush-handle\">\n                  <button class=\"button button--gold button--icon button--icon--plus button\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-plus\"><span>+</span></button>\n                  <button class=\"button button--gold button--icon button--icon--minus button\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-minus\"><span>-</span></button>\n                </div>\n              </div>\n            </div>\n            <div class=\"button-group crop-edits crop-edits-toggle\">\n              <div>\n                <h4 class=\"button-label\">Undo</h4>\n                <button class=\"button button--white button--small\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-undo\">\n                  <span>Undo</span>\n                </button>\n              </div>\n              <div>\n                <h4 class=\"button-label\">Clear</h4>\n                <button class=\"button button--red button--small clear\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-clear\">\n                  <span>Clear all</span>\n                </button>\n              </div>\n            </div>\n            <div class=\"button-group crop-edits-pre\">\n              <input type=\"checkbox\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-preview\" name=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-preview\" class=\"crop-preview-input\" />\n              <label for=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_crop-preview\" class=\"crop-preview-label\">\n                <span class=\"crop-preview-label__icon\"></span>\n                <span class=\"crop-preview-label__txt\">Preview</span>\n              </label>\n            </div>\n          </div>\n        </div>\n      </div>\n      <div class=\"interface-restart interface-restart__button\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n        <span>Start over</span>\n      </div>\n    </div>\n  </div>\n</div>\n";
},"useData":true});
this["GameApplication"]["templates"]["interface_saveimage"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_interface_saveimage\" class=\"screen-wrapper "
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-saveimage interface-saveimage\">\n  <div class=\"interface_buttons\">\n    <div class=\"interface_buttons_left\">\n      <button class=\"interface-restart button--filler\"><span class=\"interface-restart__button button button--orange button--small button--icon button--icon--restart\"><span>Start over</span></span><span class=\"interface-restart__txt\">Start over</span></button>\n    </div>\n    <div class=\"interface_buttons-centered\">\n      <button class=\"button button--red interface-back\">\n        <span>Back</span>\n      </button>\n      <button class=\"button button--blue interface-download\">        \n        <span>Download</span>\n      </button>\n      <div class=\"interface-restart interface-restart-mobile\">\n        <button class=\"button button--orange button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n      </div>\n    </div>\n    <div class=\"interface_buttons_right interface_buttons_crop\">\n      <div class=\"interface-restart interface-restart__button\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n        <span>Start over</span>\n      </div>\n    </div>\n  </div>\n</div>";
},"useData":true});
this["GameApplication"]["templates"]["interface_takephoto"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_interface_takephoto\" class=\"screen-wrapper "
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-takephoto\">\n  <h2 class=\"with-highlight\">Position yourself</h2>\n  <div class=\"interface_buttons\">\n    <div class=\"interface_buttons_left\">\n      <button class=\"interface-restart button--filler\"><span class=\"interface-restart__button button button--orange button--small button--icon button--icon--restart\"><span>Start over</span></span><span class=\"interface-restart__txt\">Start over</span></button>\n    </div>\n    <div class=\"interface_buttons-centered\">\n      <button class=\"button button--red interface-back\">\n        <span>Back</span>\n      </button>\n      <button class=\"button button--white interface-take\">\n        <span>Take photo</span>\n      </button>\n      <div class=\"interface-restart interface-restart-mobile\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n      </div>\n    </div>\n    <div class=\"interface_buttons_right\">\n      <div class=\"interface-restart interface-restart__button\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n        <span>Start over</span>\n      </div>\n    </div>\n  </div>\n  <div class=\"interface_countdown\">\n    <ul>\n      <li>1</li>\n      <li>2</li>\n      <li class=\"active\">3</li>\n    </ul>\n  </div>\n</div>";
},"useData":true});
this["GameApplication"]["templates"]["interface_uploadphoto"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_interface_uploadphoto\" class=\"screen-wrapper "
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-uploadphoto\">\n  <h2 class=\"with-highlight\">Position your photo</h2>\n  <div class=\"interface_buttons\">\n    <div class=\"interface_buttons_left\">\n      <button class=\"interface-restart button--filler\"><span class=\"interface-restart__button button button--orange button--small button--icon button--icon--restart\"><span>Start over</span></span><span class=\"interface-restart__txt\">Start over</span></button>\n    </div>\n    <div class=\"interface_buttons-centered\">\n      <button class=\"button button--red interface-button interface-back\">\n        <span>Back</span>\n      </button>\n      <label class=\"button button--white "
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-imageLoader_label\" for=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_imageLoader\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_imageLoader_label\">\n        <span>Pick another file</span>\n      </label>\n      <input type=\"file\" accept=\"image/*\" id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_imageLoader\" name=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_imageLoader\" style=\"display: none\"/>\n      <button id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_nextStep\" class=\"button button--white interface-next\">\n        <span>Next</span>\n      </button>\n      <div class=\"interface-restart interface-restart-mobile\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n      </div>\n    </div>\n    <div class=\"interface_buttons_right interface_buttons_zoom\">\n      <div class=\"button-wrapper interface_button_sides\">\n        <div class=\"button-tab\">\n          <div class=\"button-tab__bg\"></div>\n          <div class=\"button-tab__buttons\">\n            <h4>Adjust size</h4>\n            <button class=\"button button--gold button--icon button--icon--plus interface-zoomin\">\n              <span>+</span>\n            </button>\n            <button class=\"button button--gold button--icon button--icon--minus interface-zoomout\">\n              <span>-</span>\n            </button>\n          </div>\n        </div>\n      </div>\n      <div class=\"interface-restart interface-restart__button\">\n        <button class=\"button button--gold button--icon button--icon--restart\">\n          <span>Start over</span>\n        </button>\n        <span>Start over</span>\n      </div>\n    </div>\n  </div>\n  <canvas id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_imageCanvas\" ></canvas>\n</div>\n";
},"useData":true});
this["GameApplication"]["templates"]["intro"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_intro\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-intro screen-wrapper\">\n\n  <div class=\"img--mario\"></div>\n  <div class=\"photo photo--1 photo--frame\">1</div>\n  <div class=\"photo photo--2 photo--frame\">2</div>\n  <div class=\"photo photo--3 photo--frame\">3</div>\n  <div class=\"photo photo--4 photo--frame\">4</div>\n  <div class=\"img--compass\"></div>\n  <div class=\"img--logo\"></div>\n\n  <footer>\n    <div class=\"footer__content\">\n      <h1>Postcard Creator</h1>\n      <button class=\"button button--white interface-go\">\n        <span>Get started!</span>\n      </button>\n    </div>\n\n  </footer>\n\n</div>\n";
},"useData":true});
this["GameApplication"]["templates"]["main"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div class=\"application\">\n  <div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_stage-container\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-stage-container\"></div>\n  <button id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_music\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-application-music button button--white button--icon button--icon--audio\"><span>Audio</span></button>\n</div>";
},"useData":true});
this["GameApplication"]["templates"]["modal-app"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-modal-wrapper "
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-modal--"
    + alias4(((helper = (helper = helpers.modifier || (depth0 != null ? depth0.modifier : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"modifier","hash":{},"data":data}) : helper)))
    + "\">\n  <div class=\"modal-char modal-char--mobile\"></div>\n  <div class=\"modal-content\">\n    <div class=\"modal-char\"></div>\n    <div class=\"copy\">\n      <h3 class=\"modal-title\">"
    + alias4(((helper = (helper = helpers.title || (depth0 != null ? depth0.title : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"title","hash":{},"data":data}) : helper)))
    + "</h3>\n      <p class=\"modal-desc\">"
    + alias4(((helper = (helper = helpers.body || (depth0 != null ? depth0.body : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"body","hash":{},"data":data}) : helper)))
    + "</p>\n      <div class=\"buttons-container\">\n        <div class=\"button-wrapper\">\n          <button class=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_modal-alert-buttons button button--red button--small\" data-return=\"false\">\n            <span>"
    + alias4(((helper = (helper = helpers.buttonN || (depth0 != null ? depth0.buttonN : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"buttonN","hash":{},"data":data}) : helper)))
    + "</span>\n          </button>\n        </div>\n        <div class=\"button-wrapper\">\n          <button class=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_modal-alert-buttons button button--"
    + alias4(((helper = (helper = helpers.buttonColor || (depth0 != null ? depth0.buttonColor : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"buttonColor","hash":{},"data":data}) : helper)))
    + " button--small\" data-return=\"true\">\n            <span>"
    + alias4(((helper = (helper = helpers.buttonY || (depth0 != null ? depth0.buttonY : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"buttonY","hash":{},"data":data}) : helper)))
    + "</span>\n          </button>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n";
},"useData":true});
this["GameApplication"]["templates"]["modal"] = Handlebars.partials = Handlebars.template({"compiler":[7,">= 4.0.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, alias1=depth0 != null ? depth0 : (container.nullContext || {}), alias2=helpers.helperMissing, alias3="function", alias4=container.escapeExpression;

  return "<div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_modal\" class=\""
    + alias4(((helper = (helper = helpers.cssUnique || (depth0 != null ? depth0.cssUnique : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"cssUnique","hash":{},"data":data}) : helper)))
    + "-modal\">\n  <div id=\""
    + alias4(((helper = (helper = helpers.appNS || (depth0 != null ? depth0.appNS : depth0)) != null ? helper : alias2),(typeof helper === alias3 ? helper.call(alias1,{"name":"appNS","hash":{},"data":data}) : helper)))
    + "_modal-wrapper\">\n  </div>\n</div>\n";
},"useData":true});

/*
  PIXI Application Container
  =======================================
  - 
  - 
  - *Created*         2016-05-04 09:49:41
  - *namespace*       Nintendo
  - *Requirements*    null
  - *Description*     The PIXI namespace container
  - 
  - *Edited*          2016-05-16 11:58:29
  - *Version*         0.1
 */

(function() {
  "use strict";
  var appNS, base;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  window[appNS] || (window[appNS] = {});

  (base = window[appNS]).Nintendo || (base.Nintendo = {});

  (function(NS, $) {
    return NS.PIXIApplication = (function() {
      function PIXIApplication() {}

      PIXIApplication.parent = NS;

      return PIXIApplication;

    })();
  })(window[appNS].Nintendo, jQuery);

}).call(this);


/*
  Sticker PIXI extension
  =======================================
  - 
  - 
  - *Created*         2016-05-04 09:42:33
  - *namespace*       game.Nintendo.PIXIApplication
  - *Requirements*    PIXI, jQuery
  - *Description*     This is a PIXI extension that provides sticker functionality
  - 
  - *Edited*          2016-06-13 15:05:54
  - *Version*         1.0
 */

(function() {
  "use strict";
  var appNS,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  (function(NS, $) {
    var pauseEvent;
    $(window).on('pointerdown', function(e) {
      return setTimeout(function() {
        return $(window).trigger('sticker:unfocus');
      }, 30);
    });
    pauseEvent = function(e) {
      if (e) {
        if (e.stopPropagation) {
          e.stopPropagation();
        }
        if (e.preventDefault) {
          e.preventDefault();
        }
        e.cancelBubble = true;
        e.returnValue = false;
      }
      return false;
    };
    return NS.Sticker = (function(superClass) {
      extend(Sticker, superClass);

      Sticker.deleteButtonTexture = null;

      Sticker.resizeButtonTexture = null;

      Sticker.prototype.helperColor = 0x00c6ff;

      Sticker.prototype.helperAlpha = 0.5;

      Sticker.prototype.hasStroke = false;

      Sticker.prototype.texture = null;

      Sticker.prototype.hasFocus = false;

      Sticker.prototype._rotation = 0;

      Sticker.prototype.radius = 0;

      Sticker.prototype.diameter = 0;

      Sticker.prototype.clickCancel = false;

      Sticker.prototype.ID = null;

      Sticker.prototype.buttonScale = 0.5;

      Sticker.prototype.indicatorScale = 1;

      Sticker.prototype.sprite = null;

      Sticker.prototype.indicator = null;

      Sticker.prototype.buttonDelete = null;

      Sticker.prototype.buttonResize = null;


      /*
        public constructor
        -------------------------
        Constructs the sticker
        __Properties__
        - *int* @texture The sticker graphics
       */

      function Sticker(texture, isKart, hasControls) {
        this.texture = texture;
        this.isKart = isKart != null ? isKart : false;
        this.hasControls = hasControls != null ? hasControls : true;
        Sticker.__super__.constructor.apply(this, arguments);
      }


      /*
        public init
        -------------------------
        Initialises the sticker, setting up all of the interaction and display
       */

      Sticker.prototype.init = function() {
        $(window).trigger('sticker:added', this);
        this.sprite = new PIXI.Sprite(this.texture);
        this.sprite.anchor.x = 0.5;
        this.sprite.anchor.y = 0.5;
        if (!this.isKart) {
          this.sprite.width = this.sprite.width * 0.3;
          this.sprite.height = this.sprite.height * 0.3;
        }
        this.setDimensions(this.sprite.width, this.sprite.height);
        if (this.hasControls) {
          this.indicator = new PIXI.Graphics();
          this.setIndicatorGraphics();
          this.indicator.alpha = 0;
          this.indicator.scale.x = 0.1;
          this.indicator.scale.y = 0.1;
          this.addChild(this.indicator);
        }
        this.addChild(this.sprite);
        if (this.hasControls) {
          if (NS.Sticker.deleteButtonTexture) {
            this.buttonDelete = new PIXI.Sprite(NS.Sticker.deleteButtonTexture);
            this.buttonDelete.scale.x = this.buttonScale;
            this.buttonDelete.scale.y = this.buttonScale;
            this.buttonDelete.anchor.x = 0.5;
            this.buttonDelete.anchor.y = 0.5;
            this.buttonDelete.alpha = 0;
            this.setDeleteButtonPosition();
            this.addChild(this.buttonDelete);
            this.buttonDelete.interactive = true;
            this.buttonDelete.on('mouseup', (function(e) {
              return this.onDelete(e);
            }).bind(this));
            this.buttonDelete.on('touchend', (function(e) {
              return this.onDelete(e);
            }).bind(this));
          }
          if (NS.Sticker.resizeButtonTexture) {
            this.buttonResize = new PIXI.Sprite(NS.Sticker.resizeButtonTexture);
            this.buttonResize.scale.x = this.buttonScale;
            this.buttonResize.scale.y = this.buttonScale;
            this.buttonResize.anchor.x = 0.5;
            this.buttonResize.anchor.y = 0.5;
            this.buttonResize.alpha = 0;
            this.setResizeButtonPosition();
            this.addChild(this.buttonResize);
            this.buttonResize.interactive = true;
            this.buttonResize.on('pointerdown', (function(e) {
              var _e;
              _e = e || window.event;
              pauseEvent(window.event);
              $(window).trigger('sticker:mousedown', this);
              this.onMouseDownResize(e);
              return pauseEvent(_e);
            }).bind(this));
            this.buttonResize.on('pointerup', (function(e) {
              $(window).trigger('sticker:mouseup', this);
              return this.onMouseUpResize(e);
            }).bind(this));
            this.buttonResize.on('pointeroutside', (function(e) {
              $(window).trigger('sticker:mouseup', this);
              return this.onMouseUpResize(e);
            }).bind(this));
            this.buttonResize.on('pointermove', (function(e) {
              return this.onMouseMoveResize(e);
            }).bind(this));
          }
          this.mouseDown = false;
          this.offsetPosition = {
            x: 0,
            y: 0
          };
          this.mousPosStart = null;
          this.interactive = true;
          this.sprite.interactive = true;
          this.sprite.on('pointerover', (function(e) {
            return $('body').css('cursor', 'all-scroll');
          }).bind(this));
          this.sprite.on('pointerout', (function(e) {
            return $('body').css('cursor', 'default');
          }).bind(this));
          this.sprite.on('pointermove', (function(e) {
            var _e;
            _e = e || window.event;
            pauseEvent(window.event);
            this.onMouseMove(e);
            return pauseEvent(_e);
          }).bind(this));
          this.sprite.on('pointerdown', (function(e) {
            var _e;
            _e = e || window.event;
            pauseEvent(window.event);
            $(window).trigger('sticker:mousedown', this);
            this.focus();
            this.onMouseDown(e);
            return pauseEvent(_e);
          }).bind(this));
          this.sprite.on('pointerup', (function(e) {
            $(window).trigger('sticker:mouseup', this);
            return this.onMouseUp(e);
          }).bind(this));
          $(window).on('sticker:deleted.' + this.getID(), (function(e, target) {
            return this.detectDestroy();
          }).bind(this));
          $(window).on('sticker:focus.' + this.getID(), (function(e, target) {
            if (target !== this) {
              return this.unfocus();
            }
          }).bind(this));
          $(window).on('sticker:unfocus.' + this.getID(), (function(e, target) {
            if (!this.clickCancel) {
              this.unfocus();
            }
            return this.clickCancel = false;
          }).bind(this));
          $(window).on('sticker:disable.' + this.getID(), (function(e, target) {
            this.unfocus();
            this.disable();
            return this.clickCancel = false;
          }).bind(this));
          $(window).on('sticker:enable.' + this.getID(), (function(e, target) {
            return this.enable();
          }).bind(this));
          $(window).on('keydown.' + this.getID(), this.onKeyPress.bind(this));
          $(window).on('keyup.' + this.getID(), this.onKeyUp.bind(this));
        }
      };

      Sticker.prototype.addHitArea = function(poly) {
        this.sprite.hitArea = new PIXI.Polygon(poly);
      };


      /*
        private getID
        -------------------------
        Get the unique ID of the sticker.
       */

      Sticker.prototype.getID = function() {
        var i, possible;
        if (this.ID) {
          return this.ID;
        }
        this.ID = "STICKER";
        possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        i = 0;
        while (i < 5) {
          this.ID += possible.charAt(Math.floor(Math.random() * possible.length));
          i++;
        }
        return this.ID;
      };


      /*
        public detectDestroy
        -------------------------
        Detect whether this object needs destruction
       */

      Sticker.prototype.detectDestroy = function() {
        if (this.parent === null) {
          this.destroy();
        }
      };


      /*
        public destroy
        -------------------------
        Destroys the sticker and attemots to remove it from memory
       */

      Sticker.prototype.destroy = function() {
        Sticker.__super__.destroy.apply(this, arguments);
        $(window).off("." + this.getID());
      };


      /*
        public focus
        -------------------------
        Attempts to focus the sticker and display its controls and indicator
       */

      Sticker.prototype.focus = function() {
        if (!this.hasControls) {
          return;
        }
        if (this.hasFocus === true) {
          return;
        }
        this.hasFocus = true;
        $(window).trigger('sticker:focus', this);
        this.indicator.alpha = 1;
        this.indicator.scale.x = 1;
        this.indicator.scale.y = 1;
        this.buttonDelete.alpha = 1;
        this.buttonResize.alpha = 1;
        setTimeout((function() {
          this.buttonDelete.interactive = true;
          this.buttonResize.interactive = true;
        }).bind(this), 500);
      };


      /*
        public unfocus
        -------------------------
        Attempts to unfocus the sticker. Hiding it's indicator and controls.
       */

      Sticker.prototype.unfocus = function() {
        if (this.hasFocus === false) {
          return;
        }
        this.hasFocus = false;
        this.indicator.alpha = 0;
        this.indicator.scale.x = 0.1;
        this.indicator.scale.y = 0.1;
        this.buttonDelete.alpha = 0;
        this.buttonResize.alpha = 0;
        setTimeout((function() {
          this.buttonDelete.interactive = false;
          this.buttonResize.interactive = false;
        }).bind(this), 500);
      };


      /*
        public enable
        -------------------------
        Attempts to enable the sticker, making all of the relevant elements interactive
       */

      Sticker.prototype.enable = function() {
        this.buttonResize.interactive = true;
        this.buttonDelete.interactive = true;
        this.interactive = true;
        this.sprite.interactive = true;
      };


      /*
        public disable
        -------------------------
        Attempts to disable the sticker, making all of the relevant elements non-interactive
       */

      Sticker.prototype.disable = function() {
        this.buttonResize.interactive = false;
        this.buttonDelete.interactive = false;
        this.interactive = false;
        this.sprite.interactive = false;
      };


      /*
        public setRotation
        -------------------------
        Sets the rotation of the sticker
        __Properties__
        - *float* __rotation__ The rotation of the sticker in radians
       */

      Sticker.prototype.setRotation = function(rotation) {
        this.sprite.rotation = rotation;
      };


      /*
        public getRotation
        -------------------------
        Returns the rotation of the sticker in radians
       */

      Sticker.prototype.getRotation = function() {
        return this.sprite.rotation || 0;
      };


      /*
        public setRadius
        -------------------------
        Sets the radius of the sticker. Updates the sprite dimensions
        __Properties__
        - *float* __radius__ The target radius of the sticker.
       */

      Sticker.prototype.setRadius = function(radius) {
        var w;
        this.radius = radius;
        w = radius * 2 - 40;
        if (this.ratio > 1) {
          this.sprite.width = w * this.ratio;
          this.sprite.height = w;
        } else {
          this.sprite.width = w;
          this.sprite.height = w / this.ratio;
        }
        this.setDimensions(this.sprite.width, this.sprite.height);
        this.setDeleteButtonPosition();
        this.setResizeButtonPosition();
        return this.setIndicatorGraphics();
      };


      /*
        public getRadius
        -------------------------
        Returns the radius of the sticker, derived from the sticker diameter
       */

      Sticker.prototype.getRadius = function() {
        return this.diameter / 2 + 20;
      };


      /*
        public setDeleteButtonPosition
        -------------------------
        Positions the delete button based on the diameter and the angle (-135deg) at which the button should appear.
       */

      Sticker.prototype.setDeleteButtonPosition = function() {
        var rad, radius;
        if (!this.buttonDelete) {
          return;
        }
        rad = -2.35619449;
        radius = this.getRadius() * this.indicatorScale;
        this.buttonDelete.position.x = Math.cos(rad) * radius;
        this.buttonDelete.position.y = Math.sin(rad) * radius;
      };


      /*
        public setResizeButtonPosition
        -------------------------
        Positions the resize button based on the diameter and the angle (45deg) at which the button should appear.
       */

      Sticker.prototype.setResizeButtonPosition = function() {
        var rad, radius;
        if (!this.buttonResize) {
          return;
        }
        if (this.mouseDownResize) {
          return;
        }
        rad = 0.785398;
        radius = this.getRadius() * this.indicatorScale;
        this.buttonResize.position.x = Math.cos(rad) * radius;
        this.buttonResize.position.y = Math.sin(rad) * radius;
      };


      /*
        public setIndicatorGraphics
        -------------------------
        Sets up the indicator graphic.
       */

      Sticker.prototype.setIndicatorGraphics = function() {
        var radius;
        radius = this.getRadius() * this.indicatorScale;
        this.indicator.clear();
        this.indicator.beginFill(this.helperColor, this.helperAlpha);
        this.indicator.drawCircle(0, 0, radius);
      };


      /*
        public setRadius
        -------------------------
        Sets the radius of the sticker. Updates the sprite dimensions
        __Properties__
        - *float* __radius__ The target radius of the sticker.
       */

      Sticker.prototype.setDimensions = function(w1, h) {
        this.w = w1;
        this.h = h;
        if (this.w > this.h) {
          this.diameter = this.h;
        } else {
          this.diameter = this.w;
        }
        this.ratio = this.w / this.h;
      };


      /* EVENT LISTENERS */

      Sticker.prototype.onKeyUp = function(e) {
        this.shiftKey = false;
      };

      Sticker.prototype.onKeyPress = function(e) {
        var distance;
        this.detectDestroy();
        if (!this.hasFocus) {
          return;
        }
        distance = 1;
        if (e.shiftKey || e.metaKey || e.altKey || e.ctrlKey) {
          this.shiftKey = true;
          distance = 10;
        }
        if (e.which === 8 || e.which === 46) {
          this.unfocus();
          this.onDelete();
        }
        if (e.which === 27) {
          this.unfocus();
        }
        if (e.which === 37) {
          this.position.x = this.position.x - distance;
        }
        if (e.which === 39) {
          this.position.x = this.position.x + distance;
        }
        if (e.which === 38) {
          this.position.y = this.position.y - distance;
        }
        if (e.which === 40) {
          this.position.y = this.position.y + distance;
        }
        if (e.which === 219) {
          this.setRadius(this.radius - distance);
        }
        if (e.which === 221) {
          this.setRadius(this.radius + distance);
        }
      };

      Sticker.prototype.onMouseDown = function(e) {
        var _e, parent;
        this.clickCancel = true;
        parent = this.parent;
        parent.removeChild(this);
        parent.addChild(this);
        this.mouseDown = true;
        this.mousPosStart = e.data.getLocalPosition(this.parent);
        this.offsetPosition.x = this.position.x - this.mousPosStart.x;
        this.offsetPosition.y = this.position.y - this.mousPosStart.y;
        _e = e || window.event;
        pauseEvent(window.event);
        return pauseEvent(_e);
      };

      Sticker.prototype.onMouseUp = function(e) {
        this.mouseDown = false;
      };

      Sticker.prototype.onMouseMove = function(e) {
        var _e;
        if (this.mouseDown === true) {
          this.mousePosition = e.data.getLocalPosition(this.parent);
          this.position.x = this.mousePosition.x + this.offsetPosition.x;
          this.position.y = this.mousePosition.y + this.offsetPosition.y;
          $(window).trigger('sticker:move', this);
          _e = e || window.event;
          pauseEvent(window.event);
          return pauseEvent(_e);
        }
      };

      Sticker.prototype.onMouseDownResize = function(e) {
        var _e;
        this.clickCancel = true;
        this.mouseDownResize = true;
        _e = e || window.event;
        pauseEvent(window.event);
        return pauseEvent(_e);
      };

      Sticker.prototype.onMouseUpResize = function(e) {
        this.mouseDownResize = false;
        this._rotation = this.sprite.rotation;
        this.setResizeButtonPosition();
      };

      Sticker.prototype.onMouseMoveResize = function(e) {
        var _e, distX, distY, distance, mousepos, rad, radius;
        if (this.mouseDownResize === true) {
          mousepos = e.data.getLocalPosition(this.parent);
          distX = mousepos.x - this.position.x;
          distY = mousepos.y - this.position.y;
          rad = Math.atan2(distY, distX);
          distance = Math.sqrt(distX * distX + distY * distY);
          radius = this.getRadius() * this.indicatorScale;
          this.buttonResize.position.x = Math.cos(rad) * radius;
          this.buttonResize.position.y = Math.sin(rad) * radius;
          if (this.shiftKey !== true) {
            this.setRotation(rad + this._rotation - 0.785398);
          }
          this.setRadius(distance / this.indicatorScale);
          $(window).trigger('sticker:resize', this);
          _e = e || window.event;
          pauseEvent(window.event);
          return pauseEvent(_e);
        }
      };

      Sticker.prototype.onDelete = function(e) {
        this.parent.removeChild(this);
        $(window).trigger('sticker:deleted', this);
      };

      return Sticker;

    })(PIXI.Container);
  })(window[appNS].Nintendo.PIXIApplication, jQuery);

}).call(this);


/*
  Main Application file
  =======================================
  - 
  - 
  - *Created*         2016-03-14 13:51:03
  - *namespace*       Nintendo.Game
  - *Requirements*    jQuery, handlebars
  - *Description*     The main application file. This is responsible for transitioning screens and application level logic.
                      This class is a singleton and should never be instanciated directly
  - 
  - *Edited*          2016-06-09 09:35:31
  - *Version*         1.0
 */

(function() {
  "use strict";
  var appNS, base, kingdons, sectionclasses;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  window[appNS] || (window[appNS] = {});

  (base = window[appNS]).Nintendo || (base.Nintendo = {});

  sectionclasses = ['section-introduction', 'section-choose', 'section-photo', 'section-video', 'section-crop', 'section-decorate', 'section-download'];

  kingdons = ['city', 'falls', 'tostarena', 'gardens', 'bonneton', 'volbono'];

  (function(NS) {
    return NS.Application = (function() {
      var instance, privateApplication, stageInstance;

      function Application() {}

      instance = null;

      stageInstance = null;

      Application.STATE_INTRO = 0;

      Application.STATE_CHOOSE = 1;

      Application.STATE_ADD = 2;

      Application.STATE_PHOTO = 3;

      Application.STATE_UPLOAD = 4;

      Application.STATE_CROP = 5;

      Application.STATE_MODIFY = 6;

      Application.STATE_DOWNLOAD = 7;

      Application.parent = NS;

      Application.baseObject = {
        appNS: NS.CONST.APPNS,
        appPath: window.PlayNintendo.CONST.APP_ROOT_PATH,
        imagesPath: window.PlayNintendo.CONST.APP_ROOT_PATH + 'assets/img/',
        cssUnique: NS.CONST.CSSUNIQUE,
        isMobile: NS.CONST.ISMOBILE,
        hasCamera: true
      };

      privateApplication = (function() {
        function privateApplication() {
          this.music = document.createElement('audio');
          this.music.loop = true;
          this.music.setAttribute('type', 'audio/mpeg');
          this.music.volume = 0.2;
          this.musicIsPlaying = false;
          this.$musicbtn = null;
          this.$element = $('#embedtarget');
          if (NS.CONST.ISMOBILE) {
            this.$element.addClass('is-mobile');
          } else {
            this.$element.addClass('is-desktop');
          }
          this.$currentTemplateWrapper = null;
          this.stage = null;
          this.current_kingdom_index = 0;
          this.currentBorderIndex = null;
          this.setApplicationSize();
          window.addEventListener('resize', (function(e) {
            return this.setApplicationSize();
          }).bind(this));
        }

        privateApplication.prototype.init = function() {
          var html, op, xhr;
          op = this;
          html = this.getTemplate('main');
          this.$element.append(html);
          this.$stagecontainer = $("#" + NS.CONST.APPNS + "_stage-container");
          NS.Modal.init();
          this.$musicbtn = $("#" + NS.CONST.APPNS + "_music");
          this.$musicbtn.show();
          xhr = new XMLHttpRequest();
          xhr.addEventListener('progress', function(e) {
            var percentComplete;
            if (e.lengthComputable) {
              return percentComplete = e.loaded / e.total;
            }
          });
          xhr.addEventListener('load', (function(_this) {
            return function(blob) {
              if (xhr.status === 200) {
                _this.music.src = window.URL.createObjectURL(xhr.response);
                return Modernizr.on('videoautoplay', function(result) {
                  if (result) {
                    if (playPromise !== void 0) {
                      return playPromise.then(function() {
                        return _this.musicIsPlaying = true;
                      })["catch"](function(error) {
                        if (error) {
                          _this.musicIsPlaying = false;
                          return _this.$musicbtn.addClass('is-muted');
                        }
                      });
                    }
                  } else {
                    return _this.$musicbtn.addClass('is-muted');
                  }
                });
              }
            };
          })(this));
          xhr.open('GET', window.PlayNintendo.CONST.APP_ROOT_PATH + 'assets/audio/music.mp3');
          xhr.responseType = 'blob';
          xhr.send(null);
          this.$musicbtn.on('click', function() {
            if (op.musicIsPlaying) {
              op.trackOmnitureLink(39, 'postcard creator:toggle music', 53, 'Sound on/off button');
              $(this).addClass('is-muted');
              op.music.pause();
              return op.musicIsPlaying = false;
            } else {
              op.trackOmnitureLink(39, 'postcard creator:toggle music', 53, 'Sound on/off button');
              $(this).removeClass('is-muted');
              op.music.play();
              return op.musicIsPlaying = true;
            }
          });
          NS.Application.Model.setData('kingdom', null);
          $(window).on('sticker:added', (function(e) {}).bind(this));
          return this.goIntro();
        };

        privateApplication.prototype.addApplicationTemplate = function() {
          var html;
          html = this.getTemplate('application');
          this.$stagecontainer.html(html);
          this.$subapplicationcontainer = $("#" + NS.CONST.APPNS + "_controls");
          this.hasApplicationTemplate = true;
        };

        privateApplication.prototype.getTemplate = function(name, variables) {
          var html, template, vars;
          if (variables == null) {
            variables = {};
          }
          if (!NS.CONST.HASCAMERA || !NS.localMediaStream) {
            variables.hasCamera = false;
          }
          template = window["GameApplication"].templates[name];
          vars = $.extend({}, NS.Application.baseObject, variables);
          html = template(vars);
          return html;
        };

        privateApplication.prototype.addTemplate = function(name, changeState, variables, shoudlAnimate, appTemplate) {
          var html, restartBtn;
          if (changeState == null) {
            changeState = null;
          }
          if (variables == null) {
            variables = {};
          }
          if (shoudlAnimate == null) {
            shoudlAnimate = true;
          }
          if (appTemplate == null) {
            appTemplate = true;
          }
          if (appTemplate && !this.hasApplicationTemplate) {
            this.addApplicationTemplate();
            NS.Application.getStage();
          }
          html = this.getTemplate(name, variables);
          if (appTemplate) {
            this.$subapplicationcontainer.html(html);
          } else {
            this.$stagecontainer.html(html);
            this.hasApplicationTemplate = false;
          }
          if (this.$currentTemplateWrapper) {
            this.$currentTemplateWrapper.off('click');
          }
          this.$currentTemplateWrapper = $("#" + NS.CONST.APPNS + "_" + name);
          if (changeState !== null) {
            NS.Application.Model.setData('state', changeState, 'application');
          }
          if (shoudlAnimate) {
            setTimeout((function(_this) {
              return function() {
                return _this.$currentTemplateWrapper.addClass('animate-in');
              };
            })(this), 100);
          }
          restartBtn = $('.interface-restart', this.$currentTemplateWrapper);
          if (restartBtn[0]) {
            restartBtn.on('click', (function(e) {
              return NS.Modal.open('modal-app', {
                modifier: 'alert',
                title: 'Your progress will be lost.',
                body: 'Are you sure you want to start over?',
                buttonY: 'Restart',
                buttonN: 'Cancel',
                buttonColor: 'gold'
              }, true, (function(r) {
                if (r === 'true') {
                  this.trackOmnitureLink(39, 'postcard creator:start over', 53, 'Start over button (fire on confirmation)');
                  NS.Application.Model.setData('kingdom', null);
                  NS.Application.getStage(true);
                  return this.goIntro();
                }
              }).bind(this));
            }).bind(this));
          }
          return this.$currentTemplateWrapper;
        };

        privateApplication.prototype.goIntro = function() {
          var button, compass, footer, logo, mario, photo1, photo2, photo3, photo4, stateListener, tl, wrapper;
          this.$element.removeClass(sectionclasses.join(' '));
          this.$element.addClass(sectionclasses[0]);
          wrapper = this.addTemplate('intro', NS.Application.STATE_INTRO, null, true, false);
          window._application = this;
          mario = this.$currentTemplateWrapper[0].querySelector('.img--mario');
          logo = this.$currentTemplateWrapper[0].querySelector('.img--logo');
          compass = this.$currentTemplateWrapper[0].querySelector('.img--compass');
          footer = this.$currentTemplateWrapper[0].querySelector('footer');
          button = this.$currentTemplateWrapper[0].querySelector('.button');
          photo1 = this.$currentTemplateWrapper[0].querySelector('.photo--1');
          photo2 = this.$currentTemplateWrapper[0].querySelector('.photo--2');
          photo3 = this.$currentTemplateWrapper[0].querySelector('.photo--3');
          photo4 = this.$currentTemplateWrapper[0].querySelector('.photo--4');
          tl = new TimelineMax({
            pasued: true
          });
          tl.to(this.$currentTemplateWrapper[0], 0.4, {
            opacity: 1
          }).addLabel('start').staggerFrom([mario, logo], .4, {
            opacity: 0,
            yPercent: -8
          }, '0.2').from([compass], .75, {
            xPercent: -175,
            yPercent: 100,
            rotation: -25,
            ease: Expo.easeOut
          }, '-=.25').from(photo1, .75, {
            opacity: 0,
            scale: .75,
            xPercent: -50,
            yPercent: -50,
            rotation: -15,
            ease: Expo.easeOut
          }, '-=.65').from(photo2, .75, {
            opacity: 0,
            scale: .50,
            xPercent: 75,
            yPercent: -75,
            rotation: -15,
            ease: Expo.easeOut
          }, '-=.75').from(photo3, .75, {
            opacity: 0,
            scale: .50,
            xPercent: 75,
            yPercent: 75,
            rotation: 25,
            ease: Expo.easeOut
          }, '-=.75').from(photo4, .75, {
            opacity: 0,
            scale: .75,
            xPercent: -50,
            yPercent: 50,
            rotation: 15,
            ease: Expo.easeOut
          }, '-=.75').from(footer, .5, {
            yPercent: 100,
            ease: Expo.easeOut
          }, '-=.25').to(button, 0.4, {
            scale: 1,
            opacity: 1,
            onComplete: function() {
              return button.classList.add('pulse');
            }
          }, 'start+=0.5');
          if (!NS.assetsLoaded) {
            stateListener = setInterval((function() {
              if (NS.assetsLoaded) {
                NS.Preloader.hide();
                tl.play();
                clearInterval(stateListener);
              }
            }).bind(this), 100);
          } else {
            NS.Preloader.hide();
            tl.play();
          }
          $('.interface-go', wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:get started', 53, 'Get started button');
              return _this.goChooseKingdom();
            };
          })(this));
        };

        privateApplication.prototype.goChooseKingdom = function(reset) {
          var wrapper;
          if (reset == null) {
            reset = true;
          }
          this.$element.removeClass(sectionclasses.join(' '));
          this.$element.addClass(sectionclasses[1]);
          wrapper = this.addTemplate('choosekingdom', NS.Application.STATE_CHOOSE, null, true, true);
          $('[data-kingdom]', wrapper).on('click', (function(_this) {
            return function(e) {
              var kingdom;
              kingdom = e.target.getAttribute('data-kingdom');
              _this.current_kingdom_index = e.target.getAttribute('data-index');
              _this.trackOmnitureLink(39, 'postcard creator:choose kingdom:' + kingdom, 53, 'Choose your kingdom');
              return _this.goAddHeadshot(kingdom);
            };
          })(this));
        };

        privateApplication.prototype.goAddHeadshot = function(name) {
          var wrapper;
          this.$element.removeClass(sectionclasses.join(' '));
          this.$element.addClass(sectionclasses[2]);
          if (!name) {
            name = NS.Application.Model.getData('kingdom');
          }
          NS.Application.Model.setData('kingdom', name);
          wrapper = this.addTemplate('interface_addheadshot', NS.Application.STATE_ADD);
          $('.interface-back', wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:back', 53, 'Back button');
              return _this.goChooseKingdom();
            };
          })(this));
          $('.interface-upload', wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:upload image', 53, 'Upload image');
              return _this.goPhotoUpload();
            };
          })(this));
          $('.interface-webcam', wrapper).on('click', (function(_this) {
            return function(e) {
              return _this.goPhotoTake();
            };
          })(this));
        };

        privateApplication.prototype.goPhotoUpload = function() {
          var handleImage, imageLoader, wrapper;
          this.$element.removeClass(sectionclasses.join(' '));
          this.$element.addClass(sectionclasses[2]);
          wrapper = this.addTemplate('interface_uploadphoto', NS.Application.STATE_UPLOAD);
          if (NS.Application.Model.getData('kingdom') === null) {
            NS.Application.Model.setData('kingdom', 'city');
          }
          $('.interface-next', wrapper).hide();
          handleImage = function(e) {
            var orientation, reader;
            orientation = 0;
            reader = new FileReader();
            reader.onabort = function(event) {
              return console.log('aborted');
            };
            reader.onerror = function(event) {
              console.log('reader error');
              switch (event.target.error.code) {
                case event.target.error.NOT_FOUND_ERR:
                  console.log('File Not Found!');
                  break;
                case event.target.error.NOT_READABLE_ERR:
                  console.log('File is not readable');
                  break;
                case event.target.error.ABORT_ERR:
                  break;
                default:
                  console.log('An error occurred reading this file.');
              }
            };
            reader.onload = function(event) {
              var canvas, ctx, img;
              console.log('reader loaded');
              canvas = null;
              canvas = document.createElement('canvas');
              ctx = canvas.getContext('2d');
              img = new Image();
              img.onload = function() {
                var __height, __width, _height, _width, canvasSize, ratio;
                console.log('image loaded');
                canvasSize = 1000;
                ratio = img.width / img.height;
                ctx.clearRect(0, 0, canvas.width, canvas.height);
                if (ratio < 1) {
                  _width = ratio * canvasSize;
                  _height = canvasSize;
                } else {
                  _width = canvasSize;
                  _height = canvasSize / ratio;
                }
                img.width = _width;
                img.height = _height;
                canvas.width = _width;
                canvas.height = _height;
                switch (orientation) {
                  case 2:
                    ctx.translate(canvas.width, 0);
                    ctx.scale(-1, 1);
                    break;
                  case 3:
                    ctx.translate(canvas.width, canvas.height);
                    ctx.rotate(Math.PI);
                    break;
                  case 4:
                    ctx.translate(0, canvas.height);
                    ctx.scale(1, -1);
                    break;
                  case 5:
                    __height = canvas.height;
                    __width = canvas.width;
                    canvas.width = __height;
                    canvas.height = __width;
                    ctx.rotate(0.5 * Math.PI);
                    ctx.scale(1, -1);
                    break;
                  case 6:
                    __height = canvas.height;
                    __width = canvas.width;
                    canvas.width = __height;
                    canvas.height = __width;
                    ctx.rotate(0.5 * Math.PI);
                    ctx.translate(0, -img.height);
                    break;
                  case 7:
                    __height = canvas.height;
                    __width = canvas.width;
                    canvas.width = __height;
                    canvas.height = __width;
                    ctx.rotate(0.5 * Math.PI);
                    ctx.translate(canvas.width, -img.height);
                    ctx.scale(-1, 1);
                    break;
                  case 8:
                    __height = canvas.height;
                    __width = canvas.width;
                    canvas.width = __height;
                    canvas.height = __width;
                    ctx.rotate(-0.5 * Math.PI);
                    ctx.translate(-img.width, 0);
                }
                ctx.drawImage(img, 0, 0, _width, _height);
                return $(window).trigger('application:uploadPhoto', canvas);
              };
              img.src = event.target.result;
              $('.interface-next', wrapper).show();
            };
            EXIF.getData(e.target.files[0], function() {
              var exif;
              exif = EXIF.getAllTags(this);
              if (exif && exif.Orientation) {
                orientation = exif.Orientation;
              } else if (exif && exif.orientation) {
                orientation = exif.orientation;
              }
              reader.readAsDataURL(e.target.files[e.target.files.length - 1]);
            });
          };
          imageLoader = document.getElementById(NS.CONST.APPNS + "_imageLoader");
          imageLoader.addEventListener('change', handleImage, false);
          $("#" + NS.CONST.APPNS + "_imageLoader_label").click();
          $('.interface-back', wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:back', 53, 'Back button');
              return _this.goAddHeadshot();
            };
          })(this));
          $('.interface-next', wrapper).on('click', (function(_this) {
            return function(e) {
              $(window).trigger('application:takePhoto');
              _this.trackOmnitureLink(39, 'postcard creator:upload done', 53, 'Next button - Upload confirmation');
              return _this.goCrop();
            };
          })(this));
          $('.interface-zoomin', wrapper).on('click', (function(_this) {
            return function(e) {
              return $(window).trigger('application:zoomIn');
            };
          })(this));
          $('.interface-zoomout', wrapper).on('click', (function(_this) {
            return function(e) {
              return $(window).trigger('application:zoomOut');
            };
          })(this));
        };

        privateApplication.prototype.goPhotoTake = function() {
          var countdown, op, wrapper;
          this.$element.removeClass(sectionclasses.join(' '));
          this.$element.addClass(sectionclasses[3]);
          wrapper = this.addTemplate('interface_takephoto', NS.Application.STATE_PHOTO);
          op = this;
          countdown = function() {
            var $countdownCounter, $countdownCounterLi, counter, ct;
            $countdownCounter = $('.interface_countdown', wrapper);
            $countdownCounterLi = $countdownCounter.find('li');
            $(wrapper).addClass('photo_countdown');
            counter = 2;
            return ct = setInterval(function() {
              $countdownCounterLi.eq(counter - 1).addClass('active');
              if (counter < 1) {
                $(window).trigger('application:takePhoto');
                op.goCrop();
                clearInterval(ct);
              }
              return counter--;
            }, 1000);
          };
          $('.interface-take', wrapper).on('click', countdown);
          $('.interface-back', wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:back', 53, 'Back button');
              return _this.goAddHeadshot();
            };
          })(this));
        };

        privateApplication.prototype.goCrop = function() {
          var $cropBrushWrapper, canvasWrapper, closeBrushToggle, wrapper;
          this.$element.removeClass(sectionclasses.join(' '));
          this.$element.addClass(sectionclasses[4]);
          wrapper = this.addTemplate('interface_crop', NS.Application.STATE_CROP);
          if (NS.Application.getStage().captureType === NS.Application.Stage.TYPE_WEBCAM) {
            $('.application', this.$element).addClass('flash-photo');
            setTimeout(function() {
              return $('.application', this.$element).removeClass('flash-photo');
            }, 500);
          }
          $cropBrushWrapper = $('.crop-brush', wrapper);
          canvasWrapper = document.getElementById(NS.CONST.APPNS + '_canvas');
          closeBrushToggle = function() {
            $cropBrushWrapper.removeClass('is-open');
            return canvasWrapper.removeEventListener('pointerdown', closeBrushToggle);
          };
          $('.crop-brush-preview', wrapper).on('click', (function(_this) {
            return function(e) {
              $cropBrushWrapper.toggleClass('is-open');
              return canvasWrapper.addEventListener('pointerdown', closeBrushToggle);
            };
          })(this));
          $('.interface-back', wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:back', 53, 'Back button');
              if (NS.Application.getStage().captureType === NS.Application.Stage.TYPE_UPLOAD) {
                _this.goPhotoUpload();
                return closeBrushToggle();
              } else if (NS.Application.getStage().captureType === NS.Application.Stage.TYPE_WEBCAM) {
                _this.goPhotoTake();
                return closeBrushToggle();
              }
            };
          })(this));
          $('.interface-add', wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:editing done', 53, 'Next button - Editing confirmation');
              _this.goPhotoShot();
              return closeBrushToggle();
            };
          })(this));
        };

        privateApplication.prototype.goPhotoShot = function() {
          var $backgroundsWrapper, $draggedElement, $stickersWrapper, backgroundsList, currentMode, stickersList, switchBtn, switchBtnBg, switchMode, wrapper;
          this.$element.removeClass(sectionclasses.join(' '));
          this.$element.addClass(sectionclasses[5]);
          wrapper = this.addTemplate('interface_additems', NS.Application.STATE_MODIFY);
          currentMode = true;
          this.$musicbtn.show();
          if (!this.currentBorderIndex) {
            this.currentBorderIndex = 1;
          }
          $(".button_background_" + this.current_kingdom_index, wrapper).parent().addClass('is-set');
          $(".button_border_" + this.currentBorderIndex, wrapper).parent().addClass('is-set');
          switchBtn = (function(_this) {
            return function(index) {
              if (_this.currentBorderIndex) {
                $(".button_border_" + _this.currentBorderIndex, wrapper).parent().removeClass('is-set');
              }
              $(".button_border_" + index, wrapper).parent().addClass('is-set');
              return _this.currentBorderIndex = index;
            };
          })(this);
          switchBtnBg = (function(_this) {
            return function(index) {
              if (_this.current_kingdom_index) {
                $(".button_background_" + _this.current_kingdom_index, wrapper).parent().removeClass('is-set');
              }
              $(".button_background_" + index, wrapper).parent().addClass('is-set');
              _this.current_kingdom_index = index;
              return NS.Application.Model.setData('kingdom', kingdons[parseInt(index - 1)]);
            };
          })(this);
          switchMode = (function(_this) {
            return function() {
              if (currentMode) {
                _this.$element.removeClass(sectionclasses.join(' '));
                _this.$element.addClass(sectionclasses[6]);
                NS.Application.Model.setData('state', NS.Application.STATE_DOWNLOAD, 'application');
                _this.$currentTemplateWrapper.addClass('is-savemode');
                currentMode = false;
                _this.$musicbtn.hide();
              } else {
                _this.$element.removeClass(sectionclasses.join(' '));
                _this.$element.addClass(sectionclasses[5]);
                NS.Application.Model.setData('state', NS.Application.STATE_MODIFY, 'application');
                _this.$currentTemplateWrapper.removeClass('is-savemode');
                currentMode = true;
                _this.$musicbtn.show();
              }
            };
          })(this);
          $(".interface-addcard", wrapper).on('click', (function(_this) {
            return function(e) {
              return NS.Modal.open('modal-app', {
                modifier: 'addkingdom',
                title: 'Ready to add a friend to your postcard?',
                body: '',
                buttonY: 'Let\'s go!',
                buttonN: 'Not now',
                buttonColor: 'gold'
              }, true, (function(r) {
                if (r === 'true') {
                  this.trackOmnitureLink(39, 'postcard creator:add a friend', 53, 'Add a friend (fire on confirmation)');
                  return this.goAddHeadshot();
                }
              }).bind(_this));
            };
          })(this));
          $stickersWrapper = $('.button-tab--stickers').parent();
          $backgroundsWrapper = $('.button-tab--backgrounds').parent();
          $(".interface-save-image", wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:save image', 53, 'Save image');
              return switchMode();
            };
          })(this));
          $backgroundsWrapper.on('click', (function(_this) {
            return function(e) {
              return $backgroundsWrapper.removeClass('is-open');
            };
          })(this));
          $(".interface-add-background", wrapper).on('click', (function(_this) {
            return function(e) {
              return $backgroundsWrapper.toggleClass('is-open');
            };
          })(this));
          $stickersWrapper.on('click', (function(_this) {
            return function(e) {
              return $stickersWrapper.removeClass('is-open');
            };
          })(this));
          $(".interface-add-sticker", wrapper).on('click', (function(_this) {
            return function(e) {
              return $stickersWrapper.toggleClass('is-open');
            };
          })(this));
          $(".interface-item-toggler", wrapper).on('click', function(e) {
            wrapper.toggleClass('is-hidden-nav');
            if (wrapper.hasClass('is-hidden-nav')) {
              return $('span', this).html('Show menu &gt;');
            } else {
              return $('span', this).html('Hide menu &lt;');
            }
          });
          $(".interface-back", wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:back', 53, 'Back button');
              if (!currentMode) {
                return switchMode();
              } else {
                return _this.goPhotoShot();
              }
            };
          })(this));
          $(".interface-download", wrapper).on('click', (function(_this) {
            return function(e) {
              _this.trackOmnitureLink(39, 'postcard creator:download image', 3, 'Download postcard');
              return NS.Application.Image.download();
            };
          })(this));
          $(".button_border", wrapper).on('click', (function(_this) {
            return function(e) {
              var index, indexParts, target;
              target = e.target;
              if (e.target.nodeName.toLowerCase() !== 'button') {
                target = target.parentNode;
              }
              indexParts = /button_border_([0-9]+)/.exec(target.className);
              index = indexParts[1];
              $(window).trigger('application:changeBorder', index);
              return switchBtn(index);
            };
          })(this));
          $(".button_background", wrapper).on('click', (function(_this) {
            return function(e) {
              var index, indexParts, target;
              target = e.target;
              if (e.target.nodeName.toLowerCase() !== 'button') {
                target = target.parentNode;
              }
              indexParts = /button_background_([0-9]+)/.exec(target.className);
              index = indexParts[1];
              $(window).trigger('application:changeBackground', index);
              return switchBtnBg(index);
            };
          })(this));
          $(".button_sticker", wrapper).on('click', (function(_this) {
            return function(e) {
              var index, indexParts;
              indexParts = /button_sticker_([0-9]+)/.exec(e.target.className);
              index = indexParts[1];
              return $(window).trigger('application:addSticker', index);
            };
          })(this));
          if (!NS.CONST.ISMOBILE) {
            stickersList = new NS.Application.ItemSlider({
              wrapper: wrapper[0].querySelector('.button-tab--stickers'),
              nav: true,
              visible: 4
            });
            backgroundsList = new NS.Application.ItemSlider({
              wrapper: wrapper[0].querySelector('.button-tab--backgrounds'),
              nav: true,
              visible: 4
            });
          }
          $draggedElement = null;
          $(document).off('.ncomGameApplication');
          $(document).on('selectstart.ncomGameApplication', function(e) {
            var $t;
            $t = $(e.target).closest('.button_sticker');
            if ($t.length) {
              e.preventDefault && e.preventDefault();
              this.dragDrop && this.dragDrop();
              return false;
            }
          });
          $(document).on('dragstart.ncomGameApplication', (function(e) {
            var $t, h, icon, img, url, urlbits, w;
            $t = $(e.target);
            $draggedElement = $t;
            if (e.originalEvent.dataTransfer.setDragImage) {
              url = $t.css('background-image');
              urlbits = /url\("([^"]+)/.exec(url);
              url = urlbits[1];
              img = new Image();
              img.src = url;
              img.width = "50";
              icon = document.createElement('div');
              icon.className = "dragAndDropGhost";
              icon.style.cssText = 'position: absolute; left: -100px;';
              icon.appendChild(img);
              document.body.appendChild(icon);
              w = img.offsetWidth;
              h = img.offsetHeight;
              e.originalEvent.dataTransfer.setDragImage(icon, w / 2, h / 2);
              $t.css('opacity', 0);
            }
          }).bind(this));
          $(document).on('dragend.ncomGameApplication', (function(e) {
            return $('.dragAndDropGhost').remove();
          }).bind(this));
          $(document).on('drop.ncomGameApplication', (function(e) {
            var $t, x, y;
            x = e.clientX;
            y = e.clientY;
            $t = $draggedElement;
            setTimeout(function() {
              return $t.animate({
                'opacity': 1
              }, 500);
            }, 50);
            return $(window).trigger('application:dropsticker', [
              {
                x: x,
                y: y
              }, $t
            ]);
          }).bind(this));
          $(document).on('dragover.ncomGameApplication', (function(e) {
            return e.preventDefault();
          }).bind(this));
          $(document).on('dragenter.ncomGameApplication', (function(e) {
            return e.preventDefault();
          }).bind(this));
          $(document).on('dragleave.ncomGameApplication', (function(e) {
            return e.preventDefault();
          }).bind(this));
        };

        privateApplication.prototype.setApplicationSize = function() {
          var elm_h, h, r, w;
          w = NS.CONST.DIMENSIONS.WIDTH;
          h = NS.CONST.DIMENSIONS.HEIGHT;
          r = h / w;
          elm_h = this.$element.width() * r;
          this.$element.height(elm_h);
        };

        privateApplication.prototype.trackOmnitureLink = function(eVar, eVarData, events, name) {
          var e;
          try {
            window.OMNITRACK(eVar, eVarData, events, name);
          } catch (error1) {
            e = error1;
            console.log(e);
          }
        };

        return privateApplication;

      })();

      Application.init = function() {
        if (!instance) {
          this.get(true).init();
        }
        return instance;
      };

      Application.get = function(fromInit) {
        if (fromInit == null) {
          fromInit = false;
        }
        if (!instance) {
          instance = new privateApplication();
          if (!fromInit) {
            instance.init();
          }
        }
        return instance;
      };

      Application.getStage = function(reset) {
        if (reset == null) {
          reset = false;
        }
        return NS.Application.Stage.get(reset);
      };

      Application.gotoPhotoTake = function() {
        this.get().goPhotoTake('desktop');
      };

      Application.gotoIntro = function() {
        this.get().goIntro();
      };

      Application.gotoApplication = function() {
        this.get().goApplication();
      };

      return Application;

    })();
  })(window[appNS].Nintendo.Game);

}).call(this);


/*

  =======================================
  - 
  - 
  - *Created*         2016-03-08 12:58:33
  - *namespace*       jQuery
  - *Requirements*    .
  - *Description*     .
  - 
  - *Edited*          2016-05-05 14:47:23
  - *Version*         0.1
 */

(function() {
  "use strict";
  var appNS, base;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  window[appNS] || (window[appNS] = {});

  (base = window[appNS]).Nintendo || (base.Nintendo = {});

  (function(NS) {
    return NS.Model = (function() {
      function Model() {}

      Model.data = {};

      Model.types = {};

      Model.reset = function() {
        this.data = {};
        return this.types = {};
      };

      Model.setData = function(key, value, namespace) {
        var trigger;
        window.model = this;
        if (typeof namespace === 'string') {
          if (typeof this.data[namespace] !== 'object') {
            this.data[namespace] = {};
          }
          this.data[namespace][key] = value;
          trigger = namespace + '.' + key;
          $(window).trigger('data:' + namespace, [this.data[namespace]]);
        } else {
          trigger = key;
          this.data[key] = value;
        }
        $(window).trigger('data:' + trigger, [value]);
      };

      Model.getData = function(key, namespace) {
        if (typeof namespace === 'string') {
          if (typeof key === 'string') {
            return this.data[namespace][key];
          } else {
            return this.data[namespace];
          }
        } else {
          return this.data[key];
        }
      };

      return Model;

    })();
  })(window[appNS].Nintendo.Game.Application);

}).call(this);


/*
  Modal Class
  =======================================
  -  Marcello
  - 
  - *Created*         2016-03-21 09:54:05
  - *namespace*       .
  - *Requirements*    .
  - *Description*     .
  - 
  - *Edited*          2016-04-06 11:30:36
  - *Version*         0.1
 */

(function() {
  "use strict";
  var appNS, base;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  window[appNS] || (window[appNS] = {});

  (base = window[appNS]).Nintendo || (base.Nintendo = {});

  (function(NS) {
    return NS.Modal = (function() {
      var initiated, instance, privateApplication;

      function Modal() {}

      instance = null;

      initiated = false;

      Modal.parent = NS;

      privateApplication = (function() {
        function privateApplication() {
          this.app = NS.Application.get();
          this.openClass = 'is-open';
          this.isOpen = false;
          this.app.$element.append(this.getTemplate('modal'));
          this.$modal = $("#" + window.PlayNintendo.CONST.APP_NAMESPACE + "_modal");
          this.$wrapper = $("#" + window.PlayNintendo.CONST.APP_NAMESPACE + "_modal-wrapper");
          this.$modal.on('click', (function(e) {
            if ($(e.target).attr('id') === (window.PlayNintendo.CONST.APP_NAMESPACE + "_modal")) {
              return this.close();
            }
          }).bind(this));
          $(document).on('keyup', (function(e) {
            if (e.keyCode === 27 && this.isOpen) {
              return this.close();
            }
          }).bind(this));
        }

        privateApplication.prototype.getTemplate = function(name, variables) {
          var html, template, vars;
          if (variables == null) {
            variables = {};
          }
          template = window[appNS].Nintendo.Game.templates[name];
          vars = $.extend(variables, NS.Application.baseObject);
          return html = template(vars);
        };

        privateApplication.prototype.open = function(template, variables, isAlert, callback) {
          var op;
          op = this;
          this.$wrapper.html('');
          this.$wrapper.append(this.getTemplate(template, variables));
          this.$modal.addClass(this.openClass);
          this.isOpen = true;
          $(window).trigger('onInteractDisable', [false]);
          if (NS.CONST.isMobile) {
            $('html, body').stop().animate({
              'scrollTop': $("#" + window.PlayNintendo.CONST.APP_NAMESPACE + "_application").offset().top
            }, 600);
          }
          if (isAlert) {
            return $("." + window.PlayNintendo.CONST.APP_NAMESPACE + "_modal-alert-buttons").on('click', (function(_this) {
              return function(e) {
                var answer;
                _this.close();
                answer = $(e.delegateTarget).attr('data-return');
                if (callback) {
                  return callback(answer);
                } else {
                  return answer;
                }
              };
            })(this));
          } else {
            return this.$wrapper;
          }
        };

        privateApplication.prototype.close = function() {
          this.isOpen = false;
          this.$modal.removeClass(this.openClass);
          this.$wrapper.html('');
          setTimeout((function() {
            return $(window).trigger('onInteractEnable', [false]);
          }).bind(this), 100);
        };

        privateApplication.prototype.help = function() {
          var $current, $currentPag, $next, $prev, activeClass, modal, move, prev, setDimensions, totalSlides;
          modal = this.open('modal-app-help', {});
          $current = $('.slide.is-active', modal);
          $prev = $('.slide.is-prev', modal);
          $next = $('.slide.is-next', modal);
          $currentPag = $('.pagination .is-active', modal);
          activeClass = 'is-active';
          totalSlides = $('.slide', modal).length;
          setDimensions = function() {
            var newH;
            newH = 0;
            $('.slide', modal).each(function(i, e) {
              if ($(e).outerHeight() > newH) {
                return newH = $(e).outerHeight();
              }
            });
            return $('.slides', modal).css({
              height: newH
            });
          };
          move = function() {
            var nextPagination, nextSlide;
            $current.removeClass(activeClass).addClass('is-prev');
            $next.removeClass('is-next').addClass(activeClass);
            $prev.removeClass('is-prev');
            $currentPag.removeClass(activeClass);
            nextSlide = $next.next();
            if (!nextSlide[0]) {
              nextSlide = $('.slide-1', modal);
            }
            nextPagination = $currentPag.next();
            if (!nextPagination[0]) {
              nextPagination = $('.pagination li[data-slide="1"]', modal);
            }
            nextPagination.addClass(activeClass);
            nextSlide.addClass('is-next');
            $prev = $current;
            $current = $next;
            $next = nextSlide;
            return $currentPag = nextPagination;
          };
          prev = function() {
            var nextPagination, prevSlide;
            $current.removeClass(activeClass).addClass('is-next');
            $next.removeClass('is-next');
            $prev.removeClass('is-prev').addClass(activeClass);
            $currentPag.removeClass(activeClass);
            prevSlide = $prev.prev();
            if (!prevSlide[0]) {
              prevSlide = $(".slide-" + totalSlides, modal);
            }
            nextPagination = $currentPag.prev();
            if (!nextPagination[0]) {
              nextPagination = $('.pagination li[data-slide="' + totalSlides + '"]', modal);
            }
            nextPagination.addClass(activeClass);
            prevSlide.addClass('is-prev');
            $next = $current;
            $current = $prev;
            $prev = prevSlide;
            return $currentPag = nextPagination;
          };
          setDimensions();
          $('.button.next', modal).on('click', move);
          $('.button.prev', modal).on('click', prev);
          $('.btn-close', modal).on('click', (function() {
            return this.close();
          }).bind(this));
          return $(window).on('resize', setDimensions);
        };

        privateApplication.prototype.finish = function(vars, img) {
          var modal, setDimensions, swapContent;
          vars.mode = NS.Application.Model.getData('selectedScreenMode');
          modal = this.open('modal-app-finish', vars);
          setDimensions = function() {
            return $(".wrapper", modal).css({
              height: $('.content-wrapper.is-active').outerHeight()
            });
          };
          swapContent = function() {
            $('.content-how').toggleClass('is-active');
            $('.content-save').toggleClass('is-active');
            return setDimensions();
          };
          $(".btn-end", modal).on('click', (function() {
            return this.close();
          }).bind(this));
          $(".btn-swap", modal).on('click', swapContent);
          setDimensions();
          return $(window).on('resize', setDimensions);
        };

        return privateApplication;

      })();

      Modal.init = function() {
        if (!initiated) {
          initiated = true;
          return instance != null ? instance : instance = new privateApplication();
        } else {
          return instance;
        }
      };

      Modal.get = function() {
        return this.init().$wrapper;
      };

      Modal.finish = function(vars) {
        var img;
        img = new Image();
        img.src = vars.preview;
        return img.onload = (function() {
          return this.init().finish(vars, img);
        }).bind(this);
      };

      Modal.help = function() {
        return this.init().help();
      };

      Modal.open = function(template, variables, isAlert, callback) {
        if (variables == null) {
          variables = {};
        }
        if (isAlert == null) {
          isAlert = false;
        }
        if (callback == null) {
          callback = null;
        }
        return this.init().open(template, variables, isAlert, callback);
      };

      Modal.close = function() {
        return this.init().close();
      };

      return Modal;

    })();
  })(window[appNS].Nintendo.Game);

}).call(this);


/*
  Modal Class
  =======================================
  -  Marcello
  - 
  - *Created*         2016-03-21 09:54:05
  - *namespace*       .
  - *Requirements*    .
  - *Description*     .
  - 
  - *Edited*          2016-05-04 11:25:24
  - *Version*         0.1
 */

(function() {
  "use strict";
  var appNS, base;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  window[appNS] || (window[appNS] = {});

  (base = window[appNS]).Nintendo || (base.Nintendo = {});

  (function(NS) {
    return NS.Preloader = (function() {
      var initiated, instance, privatePreloader;

      function Preloader() {}

      instance = null;

      initiated = false;

      Preloader.parent = NS;

      privatePreloader = (function() {
        function privatePreloader() {
          this.$element = $("#" + window.PlayNintendo.CONST.APP_NAMESPACE + "_preloader");
          this.hideClass = 'is-hidden';
        }

        privatePreloader.prototype.show = function() {
          this.$element.removeClass(this.hideClass);
        };

        privatePreloader.prototype.hide = function() {
          this.$element.addClass(this.hideClass);
        };

        return privatePreloader;

      })();

      Preloader.init = function() {
        if (!initiated) {
          initiated = true;
          if (instance == null) {
            instance = new privatePreloader();
          }
        }
        return instance;
      };

      Preloader.show = function(vars) {
        return this.init().show();
      };

      Preloader.hide = function() {
        return this.init().hide();
      };

      return Preloader;

    })();
  })(window[appNS].Nintendo.Game);

}).call(this);

(function() {
  "use strict";
  var appNS;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  (function(NS) {
    var RESIZELISTENER;
    RESIZELISTENER = null;
    return NS.Cropper = (function() {
      function Cropper(sourceCanvas, wrapper, options) {
        this.options = window[appNS].wtc.utils.deepExtend(options, {
          autofill: true,
          showBrush: true,
          brush: {
            start: 20,
            increaseBy: 5,
            max: 60,
            min: 10,
            stroke: "rgba(200,0,0,1)",
            fill: "rgba(200,0,0,0.5)"
          }
        });
        this.wrapper = wrapper;
        this.mainCanvas = sourceCanvas;
        this.canvas = document.createElement('canvas');
        this.ctx = this.canvas.getContext("2d");
        this.canvas.width = this.mainCanvas.width;
        this.canvas.height = this.mainCanvas.height;
        this.canvas.style.position = 'absolute';
        this.canvas.style.top = '50%';
        this.canvas.style.left = '50%';
        this.canvas.style.transform = 'translate(-50%, -50%)';
        this.canvas.style.opacity = 0.5;
        this.canvas.setAttribute('touch-action', 'none');
        this.brushSettings = {
          strokeStyle: this.options.brush.stroke,
          lineJoin: "round",
          lineWidth: this.options.brush.start,
          fillStyle: this.options.brush.fill
        };
        this.brushDisplay = document.createElement('div');
        this.brushDisplay.style.position = 'absolute';
        this.brushDisplay.style.border = 'solid 1px black';
        this.brushDisplay.style.borderRadius = '50%';
        this.brushDisplay.style.pointerEvents = 'none';
        this.brushDisplay.style.backgroundColor = this.options.brush.fill;
        this.brushDisplay.style.width = this.options.brush.start + 'px';
        this.brushDisplay.style.height = this.options.brush.start + 'px';
        this.brushDisplay.style.opacity = 0;
        this.brushDisplay.style.transition = 'opacity 0.4s ease';
        this.point = [];
        this.paths = [];
        this.isPainting = false;
        this.currentMode = 'paint';
        this.trackOnce = false;
        this.canvas.addEventListener('pointerdown', this.handleMouseDown.bind(this), false);
        this.canvas.addEventListener('pointermove', this.handleMouseMove.bind(this), false);
        this.canvas.addEventListener('pointerup', this.handleMouseUp.bind(this));
        RESIZELISTENER = this.handleResize.bind(this);
        window.addEventListener('resize', RESIZELISTENER);
        this.wrapper.appendChild(this.canvas);
        this.wrapper.addEventListener('pointermove', this.handleDisplayMove.bind(this));
        this.wrapper.addEventListener('pointerover', this.handleDisplayOver.bind(this));
        this.wrapper.addEventListener('pointerout', this.handleDisplayOut.bind(this));
        if (this.options.showBrush) {
          this.wrapper.appendChild(this.brushDisplay);
        }
      }

      Cropper.prototype.handleResize = function() {
        this.ctx.save();
        return this.ctx.restore();
      };

      Cropper.prototype.handleModeChange = function(event) {
        if (this.currentMode === 'paint') {
          this.brushDisplay.style.backgroundColor = 'rgba(255,255,255,1)';
          this.currentMode = 'erase';
        } else {
          this.brushDisplay.style.backgroundColor = this.brushSettings.fillStyle;
          this.currentMode = 'paint';
        }
        return this.currentMode;
      };

      Cropper.prototype.handleResetClick = function(event) {
        return this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);
      };

      Cropper.prototype.getPoint = function(event) {
        var ax, ay, rect, x, y;
        rect = this.canvas.getBoundingClientRect();
        x = event.clientX - rect.left;
        y = event.clientY - rect.top;
        ax = x / (rect.width / this.canvas.width);
        ay = y / (rect.height / this.canvas.height);
        return {
          x: ax,
          y: ay
        };
      };

      Cropper.prototype.handleDisplayMove = function(event) {
        var point, rect;
        if (this.options.showBrush) {
          rect = this.canvas.getBoundingClientRect();
          point = {
            x: event.clientX - rect.left,
            y: event.clientY - rect.top
          };
          this.brushDisplay.style.top = point.y - this.brushSettings.lineWidth / 2 + 'px';
          return this.brushDisplay.style.left = point.x - this.brushSettings.lineWidth / 2 + 'px';
        }
      };

      Cropper.prototype.handleDisplayOver = function(event) {
        console.log(event);
        if (this.options.showBrush) {
          return this.brushDisplay.style.opacity = 1;
        }
      };

      Cropper.prototype.handleDisplayOut = function(event) {
        if (this.options.showBrush) {
          return this.brushDisplay.style.opacity = 0;
        }
      };

      Cropper.prototype.handleMouseDown = function(event) {
        var e;
        console.log(event);
        if (!this.trackOnce) {
          try {
            this.trackOnce = true;
            window.OMNITRACK(39, 'postcard creator: paint mode- painting', 53, 'paint brush');
          } catch (error) {
            e = error;
            console.log(e);
          }
        }
        this.isPainting = true;
        this.point = this.getPoint(event);
        this.paths.push({
          closed: false,
          start: this.getPoint(event),
          lineWidth: this.brushSettings.lineWidth,
          points: [],
          mode: this.currentMode === 'paint' ? true : false
        });
        event.stopPropagation();
        return event.preventDefault();
      };

      Cropper.prototype.handleMouseMove = function(event) {
        var currentPath, point;
        point = this.getPoint(event);
        if (this.isPainting) {
          event.preventDefault();
          currentPath = this.paths[this.paths.length - 1];
          currentPath.points.push(point);
          this.drawPath({
            start: {
              x: this.point.x,
              y: this.point.y
            },
            points: [point],
            lineWidth: currentPath.lineWidth,
            mode: currentPath.mode
          });
          return this.point = point;
        }
      };

      Cropper.prototype.handleUndoClick = function(event) {
        var i, len, path, ref, results;
        if (this.paths.length > 0) {
          this.reset();
          this.paths.pop();
          if (this.paths.length > 0) {
            ref = this.paths;
            results = [];
            for (i = 0, len = ref.length; i < len; i++) {
              path = ref[i];
              results.push(this.drawPath(path, path.closed));
            }
            return results;
          }
        }
      };

      Cropper.prototype.handleMouseUp = function(event) {
        var i, len, path, ref, results;
        this.isPainting = false;
        ref = this.paths;
        results = [];
        for (i = 0, len = ref.length; i < len; i++) {
          path = ref[i];
          if (!path.closed) {
            path.closed = true;
            results.push(this.drawPath(path, true));
          } else {
            results.push(void 0);
          }
        }
        return results;
      };

      Cropper.prototype.handleBrushChange = function(mode, event) {
        var newSize;
        if (mode == null) {
          mode = true;
        }
        newSize = this.brushSettings.lineWidth;
        if (mode === true) {
          newSize = newSize + this.options.brush.increaseBy;
          if (newSize > this.options.brush.max) {
            newSize = this.options.brush.max;
          }
        } else if (mode === false) {
          newSize = newSize - this.options.brush.increaseBy;
          if (newSize < this.options.brush.min) {
            newSize = this.options.brush.min;
          }
        }
        this.brushSettings.lineWidth = newSize;
        this.brushDisplay.style.width = this.brushSettings.lineWidth + 'px';
        this.brushDisplay.style.height = this.brushSettings.lineWidth + 'px';
        return newSize;
      };

      Cropper.prototype.handleCropClick = function(event) {
        var bufferCanvas, bufferctx, i, len, mainCtx, path, ref, usablePaths;
        bufferCanvas = document.createElement('canvas');
        bufferctx = bufferCanvas.getContext("2d");
        mainCtx = this.mainCanvas.getContext("2d");
        if (this.paths.length > 0) {
          usablePaths = false;
          ref = this.paths;
          for (i = 0, len = ref.length; i < len; i++) {
            path = ref[i];
            if (path.mode) {
              usablePaths = true;
              break;
            }
          }
          if (usablePaths) {
            bufferCanvas.width = this.canvas.width;
            bufferCanvas.height = this.canvas.height;
            bufferctx.drawImage(this.canvas, 0, 0);
            bufferctx.globalCompositeOperation = 'source-atop';
            bufferctx.drawImage(this.mainCanvas, 0, 0);
            return bufferCanvas;
          }
        }
        bufferCanvas.width = this.mainCanvas.width;
        bufferCanvas.height = this.mainCanvas.height;
        bufferctx.drawImage(this.mainCanvas, 0, 0);
        return bufferCanvas;
      };

      Cropper.prototype.hideFill = function() {
        return this.canvas.style.visibility = 'hidden';
      };

      Cropper.prototype.showFill = function() {
        return this.canvas.style.visibility = 'visible';
      };

      Cropper.prototype.drawPath = function(path, shouldClose) {
        var i, len, point, ref;
        if (shouldClose == null) {
          shouldClose = false;
        }
        this.ctx.lineJoin = this.brushSettings.lineJoin;
        this.ctx.lineCap = this.brushSettings.lineJoin;
        this.ctx.lineWidth = path.lineWidth;
        if (!path.mode) {
          this.ctx.globalCompositeOperation = "destination-out";
          this.ctx.strokeStyle = "rgba(0,0,0,1)";
        } else {
          this.ctx.globalCompositeOperation = "source-over";
          this.ctx.strokeStyle = this.brushSettings.strokeStyle;
        }
        this.ctx.beginPath();
        this.ctx.moveTo(path.start.x, path.start.y);
        ref = path.points;
        for (i = 0, len = ref.length; i < len; i++) {
          point = ref[i];
          this.ctx.lineTo(point.x, point.y);
        }
        if (shouldClose && path.mode && this.options.autofill) {
          this.ctx.closePath();
        }
        this.ctx.stroke();
        if (shouldClose && path.mode && this.options.autofill) {
          this.ctx.fillStyle = this.brushSettings.strokeStyle;
          this.ctx.fill();
        }
      };

      Cropper.prototype.handleClearClick = function() {
        this.point = [];
        this.paths = [];
        return this.reset();
      };

      Cropper.prototype.reset = function() {
        return this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);
      };

      Cropper.prototype.destroy = function() {
        window.removeEventListener('resize', RESIZELISTENER);
        this.wrapper.removeChild(this.canvas);
        if (this.options.showBrush) {
          return this.brushDisplay.parentNode.removeChild(this.brushDisplay);
        }
      };

      return Cropper;

    })();
  })(window[appNS].Nintendo.Game.Application);

}).call(this);


/*

  =======================================
  - 
  - 
  - *Created*         2016-03-07 13:39:35
  - *namespace*       game.Nintendo.Game.Application
  - *Requirements*    .
  - *Description*     .
  - 
  - *Edited*          2016-05-11 13:21:05
  - *Version*         0.1
 */

(function() {
  "use strict";
  var appNS;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  (function(NS) {
    return NS.Image = (function() {
      function Image() {}

      Image.download = function() {
        var content, folder, image, img, m, win, zip;
        image = NS.Model.getData('outputImage');
        if (!NS.parent.CONST.ISMOBILE && !NS.parent.CONST.ISSAFARI) {
          zip = new JSZip();
          folder = zip.folder("Create-a-Postcard");
          folder.file("Create-a-Postcard.png", image.substr(22), {
            base64: true
          });
          if (JSZip.support.blob) {
            try {
              content = zip.generate({
                type: "blob"
              });
              return saveAs(content, "Create-a-Postcard.zip");
            } catch (error) {
              return console.log('Error generating the zip file');
            }
          } else {
            return window.location = "data:application/zip;base64," + zip.generate({
              type: "base64"
            });
          }
        } else {
          win = window.open();
          m = $('<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />');
          win.document.head.appendChild(m[0]);
          m = $('<meta charset="utf-8" />');
          win.document.head.appendChild(m[0]);
          m = $('<meta name="viewport", content="width=device-width, initial-scale=1, user-scalable=1, minimum-scale=1, maximum-scale=1.0" />');
          win.document.head.appendChild(m[0]);
          img = $('<img src="' + image + '" style="display: block; max-width: 100%"/>');
          return win.document.body.appendChild(img[0]);
        }
      };

      return Image;

    })();
  })(window[appNS].Nintendo.Game.Application);

}).call(this);


/*

  =======================================
  - 
  - 
  - *Created*         2016-03-07 13:39:35
  - *namespace*       game.Nintendo.Game.Application
  - *Requirements*    .
  - *Description*     .
  - 
  - *Edited*          2016-05-11 13:21:05
  - *Version*         0.1
 */

(function() {
  "use strict";
  var appNS;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  (function(NS) {
    return NS.ItemSlider = (function() {
      function ItemSlider(options) {
        var i, item, num, ref;
        this.wrapper = options.wrapper;
        this.visibleNum = options.visible;
        this.listWrapper = this.wrapper.querySelector('.button-tab__buttons');
        this.list = this.listWrapper.querySelector('ul');
        this.items = this.list.querySelectorAll('li');
        this.navUp = this.wrapper.querySelector('.list-nav.list-nav--up');
        this.navDown = this.wrapper.querySelector('.list-nav.list-nav--down');
        this.itemMargin = 0;
        this.navPadding = {};
        this.sets = {};
        this.totalHeight = 0;
        this.ItemsPerSlide = 3;
        for (num = i = 0, ref = this.items.length - 1; 0 <= ref ? i <= ref : i >= ref; num = 0 <= ref ? ++i : --i) {
          item = {
            el: this.items[num],
            isVisible: num < this.ItemsPerSlide ? true : false
          };
          this.sets['item' + num] = item;
        }
        this.resize();
        this.navUp.addEventListener('click', this.move.bind(this, 'up'));
        this.navDown.addEventListener('click', this.move.bind(this, 'down'));
        window.addEventListener('resize', this.resize.bind(this));
      }

      ItemSlider.prototype.resize = function() {
        var id, item, newH, ref;
        this.itemMargin = parseInt(window.getComputedStyle(this.items[0].querySelector('button')).getPropertyValue('margin-bottom'));
        this.totalHeight = this.list.offsetHeight - this.itemMargin;
        this.navPadding = {
          top: parseInt(window.getComputedStyle(this.listWrapper).getPropertyValue('padding-top')),
          bottom: parseInt(window.getComputedStyle(this.listWrapper).getPropertyValue('padding-bottom'))
        };
        newH = 0;
        ref = this.sets;
        for (id in ref) {
          item = ref[id];
          if (item.isVisible) {
            newH = newH + item.el.offsetHeight;
          }
        }
        this.listWrapper.style.height = newH + this.navPadding.top + this.navPadding.bottom - this.itemMargin + 'px';
        return TweenMax.to(this.list, 0.4, {
          y: this.getYPos() + 'px'
        });
      };

      ItemSlider.prototype.getYPos = function(amountToMove, direction) {
        var counter, currentYPos, id, item, ref;
        currentYPos = 0;
        counter = 0;
        ref = this.sets;
        for (id in ref) {
          item = ref[id];
          if (item.isVisible) {
            counter++;
          } else if (counter >= this.ItemsPerSlide) {
            break;
          } else {
            currentYPos = currentYPos + item.el.offsetHeight;
          }
        }
        if (currentYPos > 0) {
          currentYPos = currentYPos * -1;
        }
        return currentYPos;
      };

      ItemSlider.prototype.getNextSet = function(direction) {
        var checkitem, counter, i, id, item, key, keys, len, nextItemsId, ref;
        if (direction == null) {
          direction = 'down';
        }
        nextItemsId = [];
        counter = 0;
        checkitem = (function(_this) {
          return function(id, item) {
            if (item.isVisible) {
              nextItemsId.push(id);
              return counter++;
            } else if (counter >= _this.ItemsPerSlide && counter < _this.ItemsPerSlide * 2) {
              if (nextItemsId.length >= _this.ItemsPerSlide) {
                nextItemsId.shift();
              }
              nextItemsId.push(id);
              return counter++;
            }
          };
        })(this);
        if (direction === 'down') {
          ref = this.sets;
          for (id in ref) {
            item = ref[id];
            checkitem(id, item);
          }
        } else {
          keys = Object.keys(this.sets).reverse();
          for (i = 0, len = keys.length; i < len; i++) {
            key = keys[i];
            checkitem(key, this.sets[key]);
          }
        }
        return nextItemsId;
      };

      ItemSlider.prototype.move = function(direction) {
        var currentY, id, item, move, nextItemsId, nextY, ref;
        currentY = this.getYPos();
        nextItemsId = this.getNextSet(direction);
        nextY = 0;
        ref = this.sets;
        for (id in ref) {
          item = ref[id];
          if (nextItemsId.indexOf(id) >= 0) {
            if (!item.isVisible) {
              nextY = nextY + item.el.offsetHeight;
              item.isVisible = true;
            }
          } else {
            item.isVisible = false;
          }
        }
        if (direction === 'down') {
          move = (nextY * -1) + currentY;
          if (move * -1 < this.totalHeight) {
            return TweenMax.to(this.list, 0.4, {
              y: move
            });
          }
        } else {
          move = nextY + currentY;
          if (move <= 0) {
            return TweenMax.to(this.list, 0.4, {
              y: move
            });
          }
        }
      };

      return ItemSlider;

    })();
  })(window[appNS].Nintendo.Game.Application);

}).call(this);


/*
  Game Stage controller
  =======================================
  - 
  - 
  - *Created*         2016-03-07 13:39:35
  - *namespace*       Nintendo.Game.Application
  - *Requirements*    jQuery, PIXI
  - *Description*     The stage controller for the Game application
                      Singleton.
  - 
  - *Edited*          2016-05-16 09:49:19
  - *Version*         1.0
 */

(function() {
  "use strict";
  var appNS;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  Modernizr.addTest('getusermedia', !!Modernizr.prefixed('getUserMedia', navigator));

  (function(NS) {
    var pauseEvent;
    pauseEvent = function(e) {
      if (e) {
        if (e.stopPropagation) {
          e.stopPropagation();
        }
        if (e.preventDefault) {
          e.preventDefault();
        }
        e.cancelBubble = true;
        e.returnValue = false;
      }
      return false;
    };
    return NS.Stage = (function() {
      var PrivateStage, STATE_DRAWING, STATE_INTRO, STATE_SAVE, instance;

      function Stage() {}

      instance = null;

      STATE_INTRO = 1;

      STATE_DRAWING = 2;

      STATE_SAVE = 4;

      Stage.TYPE_UPLOAD = 0;

      Stage.TYPE_WEBCAM = 1;

      PrivateStage = (function() {
        PrivateStage.prototype.container = null;

        PrivateStage.prototype.stage = null;

        PrivateStage.prototype.renderer = null;

        PrivateStage.prototype.canvas = null;

        PrivateStage.prototype.state = null;

        PrivateStage.prototype.stageWidth = null;

        PrivateStage.prototype.stageHeight = null;

        PrivateStage.prototype.scaleFactor = null;

        PrivateStage.prototype.viewportWidth = null;

        PrivateStage.prototype.viewportHeight = null;

        PrivateStage.prototype.viewportScaleFactor = null;

        PrivateStage.prototype.photoPosition = null;

        PrivateStage.prototype.zoomLevel = 0;

        PrivateStage.prototype.fixedImageWidth = null;

        PrivateStage.prototype.imageConstrains = null;

        PrivateStage.prototype.rendering = false;

        PrivateStage.prototype.card = void 0;

        PrivateStage.prototype.captureType = null;

        PrivateStage.prototype.webcamPlaying = false;

        PrivateStage.prototype.photoMaxSize = {
          x: NS.parent.CONST.CANVASDIMENSIONS.HEIGHT,
          y: NS.parent.CONST.CANVASDIMENSIONS.HEIGHT
        };

        PrivateStage.prototype.cropper = null;

        PrivateStage.prototype.cropperHightlight = null;

        PrivateStage.prototype.cropperDiv = null;


        /*
          stage
            ... bg - image for the app
        
            containerCardWrapper
              containerCard
                containerCardBG
                containerCardPhoto
                  containerCardPhotoWrapper
                    photoSprite
                    ... mask
                    ... border
                containerCardFG
        
            containerScene
              containerSceneBg
              containerSceneForground
                ... sprites
              containerSceneLogos
                ... sprites
         */

        PrivateStage.prototype.containerCard = null;

        PrivateStage.prototype.containerCardBG = null;

        PrivateStage.prototype.containerCardPhoto = null;

        PrivateStage.prototype.containerCardPhotoWrapper = null;

        PrivateStage.prototype.photoSprite = null;

        PrivateStage.prototype.photoMask = null;

        PrivateStage.prototype.photoBorder = null;

        PrivateStage.prototype.containerScene = null;

        PrivateStage.prototype.containerSceneBg = null;

        PrivateStage.prototype.containerSceneForground = null;

        PrivateStage.prototype.containerSceneBorder = null;

        PrivateStage.prototype.containerSceneLogos = null;

        function PrivateStage(w, h, s) {
          this.container = document.querySelector("#" + window.PlayNintendo.CONST.APP_NAMESPACE + "_canvas");
          this.container.style.position = 'relative';
          this.scrollableDiv = document.createElement('div');
          this.scrollableDiv.id = window.PlayNintendo.CONST.APP_NAMESPACE + "_canvas-scoller";
          this.scrollableDiv.style.position = 'absolute';
          this.scrollableDiv.style.top = 0;
          this.scrollableDiv.style.left = 0;
          this.scrollableDiv.style.width = '100%';
          this.scrollableDiv.style.height = '100%';
          this.stage = new PIXI.Container();
          this.renderer = PIXI.autoDetectRenderer(100, 100, {
            antialias: false,
            transparent: true
          });
          this.renderer.plugins.interaction.autoPreventDefault = false;
          NS.Model.setData('renderer', this.renderer);
          this.canvas = this.renderer.view;
          this.canvas.style['touch-action'] = 'auto';
          window.addEventListener('resize', (function(e) {
            this.setViewportDimensions(this.container.clientWidth);
          }).bind(this));
          $(window).on('application:takePhoto', (function() {
            this.takePhoto();
          }).bind(this));
          $(window).on('application:zoomIn', (function(e) {
            this.zoomIn();
          }).bind(this));
          $(window).on('application:zoomOut', (function(e) {
            this.zoomOut();
          }).bind(this));
          $(window).on('application:uploadPhoto', (function(e, image) {
            this.uploadPhoto(image);
          }).bind(this));
          $(window).on('application:dropsticker', (function(e, position, $t) {
            this.dropSticker(position, $t);
          }).bind(this));
          $(window).on('application:addSticker', (function(e, index) {
            this.addSticker(index);
          }).bind(this));
          $(window).on('application:changeBorder', (function(e, index) {
            this.changeBorder(index);
          }).bind(this));
          $(window).on('data:kingdom', (function(e, value) {
            this.setCard(value);
          }).bind(this));
          $(window).on('data:application.state', (function(e, vars) {
            if (typeof vars === 'number') {
              this.setState(vars);
            }
          }).bind(this));
          $(window).on('action:download', (function(e) {
            this.setupDownload(w, h);
          }).bind(this));
          $(window).on('sticker:mousedown', (function(e) {
            this.renderer.plugins.interaction.autoPreventDefault = true;
          }).bind(this));
          $(window).on('sticker:mouseup', (function(e) {
            this.renderer.plugins.interaction.autoPreventDefault = false;
          }).bind(this));
        }

        PrivateStage.prototype.addToDOM = function() {
          this.container = document.querySelector("#" + window.PlayNintendo.CONST.APP_NAMESPACE + "_canvas");
          if (this.container && !jQuery.contains(document, this.canvas[0])) {
            this.container.appendChild(this.canvas);
            return this.container.appendChild(this.scrollableDiv);
          }
        };

        PrivateStage.prototype.reset = function(w, h, s) {
          var card, i, j, len, obj, ref, state;
          this.Card = void 0;
          this.captureType = null;
          this.webcamPlaying = false;
          if (this.cropper) {
            this.cropper.destroy();
            this.cropper = null;
          }
          this.addToDOM();
          if (this.containerSceneForground && this.containerSceneForground.children) {
            ref = this.containerSceneForground.children;
            for (j = 0, len = ref.length; j < len; j++) {
              obj = ref[j];
              if (obj && typeof obj.onDelete === 'function') {
                obj.onDelete();
              } else {
                this.stage.removeChild(obj);
              }
            }
          }
          if (this.stage.children) {
            i = this.stage.children.length - 1;
            while (i >= 0) {
              this.stage.removeChild(this.stage.children[i]);
              i--;
            }
          }
          this.stage.destroy();
          this.stage = new PIXI.Container();
          this.containerCardWrapper = new PIXI.Container();
          this.containerCard = new PIXI.Container();
          this.containerCardBG = new PIXI.Container();
          this.containerCardPhoto = new PIXI.Container();
          this.containerCardFG = new PIXI.Container();
          this.containerScene = new PIXI.Container();
          this.containerSceneBg = new PIXI.Container();
          this.containerSceneForground = new PIXI.Container();
          this.containerSceneBorder = new PIXI.Container();
          this.containerSceneLogos = new PIXI.Container();
          this.containerCardWrapper.addChild(this.containerCard);
          this.containerCard.addChild(this.containerCardPhoto);
          this.stage.addChild(this.containerCardWrapper);
          this.containerScene.addChild(this.containerSceneBg);
          this.containerScene.addChild(this.containerSceneForground);
          this.containerScene.addChild(this.containerSceneBorder);
          this.containerScene.addChild(this.containerSceneLogos);
          this.stage.addChild(this.containerCardBG);
          this.stage.addChild(this.containerScene);
          this.stage.addChild(this.containerCardFG);
          this.containerCardPhoto.on('pointerover', (function(e) {
            return this.onSpriteMouseOver();
          }).bind(this));
          this.containerCardPhoto.on('pointerout', (function(e) {
            this.canvas.style.touchAction = 'auto';
            this.renderer.plugins.interaction.autoPreventDefault = false;
            return this.onSpriteMouseOut();
          }).bind(this));
          this.containerCardPhoto.on('pointermove', (function(e) {
            e.stopPropagation();
            this.onSpriteMouseMove(e);
            return false;
          }).bind(this));
          this.containerCardPhoto.on('pointerdown', (function(e) {
            var _e;
            this.canvas.style.touchAction = 'none';
            this.renderer.plugins.interaction.autoPreventDefault = true;
            _e = e || window.event;
            pauseEvent(window.event);
            this.onSpriteMouseDown(e);
            return pauseEvent(_e);
          }).bind(this));
          this.containerCardPhoto.on('pointerup', (function(e) {
            this.canvas.style.touchAction = 'auto';
            this.renderer.plugins.interaction.autoPreventDefault = false;
            return this.onSpriteMouseUp(e);
          }).bind(this));
          this.setStageDimensions(w, h, s);
          this.setViewportDimensions(this.container.clientWidth);
          this.changeBorder(1);
          this.startRender();
          card = NS.Model.getData('card');
          this.setCard(card);
          state = NS.Model.getData('state', 'application');
          this.setState(state);
        };


        /*
          private setStageDimensions
          -------------------------
          Sets the stage dimensions using width, height and scaleFactor. These are all in real terms
          __Properties__
          - *int* @stageWidth Stage width
          - *int* @stageHeight Stage height
          - *int* @scaleFactor The scale factor, also pixel density, presented as a multiplier
         */

        PrivateStage.prototype.setStageDimensions = function(stageWidth, stageHeight, scaleFactor) {
          this.stageWidth = stageWidth;
          this.stageHeight = stageHeight;
          this.scaleFactor = scaleFactor;
          NS.Model.setData('scaleFactor', this.scaleFactor);
          NS.Model.setData('stagedimensions', {
            w: this.stageWidth * this.scaleFactor,
            h: this.stageHeight * this.scaleFactor
          });
          this.stageRatio = this.stageWidth / this.stageHeight;
          this.renderer.resize(this.stageWidth * this.scaleFactor, this.stageHeight * this.scaleFactor);
        };


        /*
          private setViewportDimensions
          -------------------------
          Sets the dimensions of the viewport and udpates the viewpors scale factor accordingly
          __Properties__
          - *int* @viewportWidth Viewport width
          - *int* @viewportHeight Viewport height
         */

        PrivateStage.prototype.setViewportDimensions = function(viewportWidth, viewportHeight) {
          this.viewportWidth = viewportWidth;
          this.viewportHeight = viewportHeight;
          if (typeof this.viewportHeight !== 'number') {
            this.viewportHeight = this.viewportWidth / this.stageRatio;
          }
          if (this.canvas) {
            this.canvas.style.width = this.viewportWidth + "px";
            this.canvas.style.height = this.viewportHeight + "px";
          }
          if (this.stageRatio < 1.4) {
            this.canvas.style.maxHeight = NS.parent.CONST.CANVASDIMENSIONS.HEIGHT + 'px';
            this.canvas.style.width = "auto";
          } else {
            this.canvas.style.maxHeight = '';
            this.canvas.style.margin = "";
          }
          this.viewportScaleFactor = $(this.canvas).width() / this.stageWidth;
        };


        /*
          private startRender
          -------------------------
          Starts rendering the scene.
         */

        PrivateStage.prototype.startRender = function() {
          var runtime;
          if (this.rendering === true) {
            return;
          }
          this.rendering = true;
          runtime = (function() {
            this.renderer.render(this.stage);
            if (this.rendering === true) {
              return requestAnimationFrame(runtime);
            }
          }).bind(this);
          requestAnimationFrame(runtime);
        };


        /*
          private stopRender
          -------------------------
          Stops rendering the scene
         */

        PrivateStage.prototype.stopRender = function() {
          if (this.rendering === false) {
            return;
          }
          this.rendering = false;
        };


        /*
          private setState
          -------------------------
          Sets the state of the Stage. This corresponds with one of the NS States, specifically:
            NS.STATE_INTRO: 0;
            NS.STATE_CHOOSE: 1;
            NS.STATE_PHOTO: 2;
            NS.STATE_UPLOAD: 3;
            NS.STATE_CROP: 4;
            NS.STATE_MODIFY: 5;
            NS.STATE_DOWNLOAD: 6;
          __Properties__
          - *int* __state__ The state of the application
         */

        PrivateStage.prototype.setState = function(state) {
          var oldState, slideCard;
          oldState = this.state;
          this.state = state;
          this.containerCardBG.visible = false;
          this.containerCardFG.visible = false;
          if (NS.parent.CONST.ISMOBILE) {
            slideCard = this.stageHeight / 2 - this.containerCardBG.height / 2 + 35;
          } else {
            slideCard = this.stageHeight / 2 - this.containerCardBG.height / 2 + 130;
          }
          $(window).trigger('sticker:disable');
          this.scrollableDiv.style.pointerEvents = 'auto';
          if (oldState === NS.STATE_DOWNLOAD && this.state < oldState) {
            this.cleanupImageDownload();
          }
          if (this.state === NS.STATE_ADD) {
            this.containerScene.visible = false;
            this.setupChoice();
          } else if (this.state === NS.STATE_UPLOAD) {
            this.scrollableDiv.style.pointerEvents = 'none';
            this.containerScene.visible = false;
            this.captureType = NS.Stage.TYPE_UPLOAD;
            if (this.cropper) {
              this.cropper.destroy();
              this.cropper = null;
              this.cropperDiv.style.display = 'none';
            }
          } else if (this.state === NS.STATE_PHOTO) {
            this.containerScene.visible = false;
            this.captureType = NS.Stage.TYPE_WEBCAM;
            if (this.cropper) {
              this.cropper.destroy();
              this.cropper = null;
              this.cropperDiv.style.display = 'none';
            }
            this.setupImageCapture();
            this.setupVideoCapture();
          } else if (this.state === NS.STATE_MODIFY) {
            this.containerCardBG.visible = true;
            this.containerCardFG.visible = true;
            this.scrollableDiv.style.pointerEvents = 'none';
            this.containerScene.visible = true;
            if (this.containerSceneBg.children <= 0) {
              this.containerSceneBg.alpha = 0;
              TweenMax.to(this.containerSceneBg, 0.4, {
                alpha: 1
              });
            }
            $(window).trigger('sticker:enable');
          } else if (this.state === NS.STATE_DOWNLOAD) {
            this.containerCardBG.visible = true;
            this.containerCardFG.visible = true;
            this.setupImageDownload();
          } else if (this.state === NS.STATE_CROP) {
            this.crop();
          }
        };


        /*
          private setupChoice
          -------------------------
          Sets the stage up for the robobot choice screen
         */

        PrivateStage.prototype.setupChoice = function() {
          var j, len, obj, ref;
          this.setCard();
          this.containerCardPhoto.interactive = false;
          this.onSpriteMouseOut();
          ref = this.containerCardPhoto.children;
          for (j = 0, len = ref.length; j < len; j++) {
            obj = ref[j];
            this.containerCardPhoto.removeChild(obj);
          }
          this.containerCardPhoto.visible = false;
        };


        /*
          private setupImageCapture
          -------------------------
          Sets the stage up for he image capture -- both image uplaod and video
         */

        PrivateStage.prototype.setupImageCapture = function() {};


        /*
          private setCard
          -------------------------
          Set the chosen robot.
          __Properties__
          - *int* __robot__ The chosen robot
         */

        PrivateStage.prototype.setCard = function(card) {
          var bg, fg;
          if (this.card === card) {
            return;
          }
          this.containerCard.visible = true;
          if (card) {
            this.card = card;
          } else if (!this.card) {
            this.card = 'city';
          }
          while (this.containerCardBG.children[0]) {
            this.containerCardBG.removeChild(this.containerCardBG.children[0]);
          }
          while (this.containerCardFG.children[0]) {
            this.containerCardFG.removeChild(this.containerCardFG.children[0]);
          }
          if (NS.parent.CONST.ISMOBILE) {
            bg = new PIXI.Sprite(PIXI.loader.resources['kingdom-' + this.card + '-small'].texture);
            fg = new PIXI.Sprite(PIXI.loader.resources['kingdom-' + this.card + '-small_fg'].texture);
          } else {
            bg = new PIXI.Sprite(PIXI.loader.resources['kingdom-' + this.card].texture);
            fg = new PIXI.Sprite(PIXI.loader.resources['kingdom-' + this.card + '_fg'].texture);
          }
          this.containerCardBG.addChild(bg);
          this.containerCardFG.addChild(fg);
        };


        /*
          private zoomIn
          -------------------------
          Zoom in the photo
         */

        PrivateStage.prototype.zoomIn = function() {
          this.zoomLevel = this.zoomLevel + 1;
          if (this.zoomLevel > 20) {
            this.zoomLevel = 20;
            return;
          }
          this.fixPhotoDimensions(this.photoSprite.width, this.photoSprite.height, false, this.zoomLevel);
          this.imageConstrains = {
            width: this.photoSprite.width,
            height: this.photoSprite.height,
            x: this.photoSprite.x,
            y: this.photoSprite.y
          };
        };


        /*
          private zoomOut
          -------------------------
          Zoom out the photo
         */

        PrivateStage.prototype.zoomOut = function() {
          this.zoomLevel = this.zoomLevel - 1;
          if (this.zoomLevel < -7) {
            this.zoomLevel = -7;
            return;
          }
          this.fixPhotoDimensions(this.photoSprite.width, this.photoSprite.height, false, this.zoomLevel);
          this.imageConstrains = {
            width: this.photoSprite.width,
            height: this.photoSprite.height,
            x: this.photoSprite.x,
            y: this.photoSprite.y
          };
        };


        /*
          private uploadPhoto
          -------------------------
          Accepts a photo upload, adds it to the stage and sets up all of the layout and decoration
          NB: A lot of this should be abstracted because it's repeated elsehwere, mais c'est la vie.
          __Properties__
          - *DOM* __image__ A canvas element representing the uploaded photo
         */

        PrivateStage.prototype.uploadPhoto = function(image) {
          this.setupImageCapture();
          this.zoomLevel = 0;
          this.fixedImageWidth = null;
          this.addPhotoGroup(image);
          this.containerCardPhoto.interactive = true;
          this.containerCardPhoto.hitArea = new PIXI.Rectangle(this.photoBorder.position.x, this.photoBorder.position.y, this.photoBorder.width, this.photoBorder.height);
        };

        PrivateStage.prototype.addPhotoGroup = function(image) {
          var imageTexture;
          if (image == null) {
            image = false;
          }
          this.containerCardPhoto.visible = true;
          if (this.containerCardPhotoWrapper) {
            while (this.containerCardPhotoWrapper.children[0]) {
              this.containerCardPhotoWrapper.removeChild(this.containerCardPhotoWrapper.children[0]);
            }
          }
          while (this.containerCardPhoto.children[0]) {
            this.containerCardPhoto.removeChild(this.containerCardPhoto.children[0]);
          }
          this.containerCardPhotoWrapper = new PIXI.Container();
          this.photoSprite = null;
          this.photoMask = null;
          this.photoBorder = null;
          this.containerCardPhoto.addChild(this.containerCardPhotoWrapper);
          imageTexture = null;
          imageTexture = image ? PIXI.Texture.fromCanvas(image) : PIXI.Texture.fromVideo(this.video);
          imageTexture.update();
          this.photoSprite = new PIXI.Sprite(imageTexture);
          this.photoSprite.anchor.x = 0.5;
          this.photoSprite.anchor.y = 0.5;
          this.containerCardPhotoWrapper.addChild(this.photoSprite);
          this.fixPhotoDimensions(this.photoSprite.width, this.photoSprite.height, image ? false : true);
          this.photoMask = new PIXI.Graphics();
          this.photoMask.beginFill();
          this.photoMask.drawRect(0, 0, this.photoMaxSize.x, this.photoMaxSize.y);
          this.photoMask.endFill();
          this.containerCardPhotoWrapper.addChild(this.photoMask);
          this.photoBorder = new PIXI.Graphics();
          this.photoBorder.lineStyle(1, 0x000000, 0);
          this.photoBorder.drawRect(0, 0, this.photoMaxSize.x, this.photoMaxSize.y);
          this.photoBorder.endFill();
          this.containerCardPhoto.addChild(this.photoBorder);
          this.positionPhotoGroup();
          this.containerCardPhotoWrapper.mask = this.photoMask;
          this.fixedImageWidth = this.photoMaxSize.x;
          this.imageConstrains = {
            width: this.photoMaxSize.x,
            height: this.photoMaxSize.y,
            x: 0,
            y: 0
          };
        };

        PrivateStage.prototype.positionPhotoGroup = function(x, y) {
          var baseY;
          baseY = 0;
          if (this.photoBorder) {
            this.photoBorder.position = {
              x: this.stageWidth / 2 - this.photoBorder.width / 2,
              y: this.stageHeight - this.photoBorder.height
            };
            if (this.photoMask) {
              this.photoMask.position = {
                x: this.stageWidth / 2 - this.photoBorder.width / 2,
                y: this.stageHeight - this.photoBorder.height
              };
            }
          }
          if (typeof x === 'number' && typeof y === 'number') {
            this.photoPosition = {
              x: x,
              y: y
            };
          } else {
            this.photoPosition = {
              x: this.stageWidth / 2,
              y: this.photoBorder.height - (this.photoSprite.height - 2) / 2
            };
          }
          this.photoSprite.position.x = this.photoPosition.x;
          return this.photoSprite.position.y = this.photoPosition.y;
        };

        PrivateStage.prototype.trim = function(c) {
          var bound, copy, ctx, i, l, pixels, trimHeight, trimWidth, trimmed, x, y;
          ctx = c.getContext('2d');
          copy = document.createElement('canvas').getContext('2d');
          pixels = ctx.getImageData(0, 0, c.width, c.height);
          l = pixels.data.length;
          i = void 0;
          bound = {
            top: null,
            left: null,
            right: null,
            bottom: null
          };
          x = void 0;
          y = void 0;
          i = 0;
          while (i < l) {
            if (pixels.data[i + 3] !== 0) {
              x = i / 4 % c.width;
              y = ~~(i / 4 / c.width);
              if (bound.top === null) {
                bound.top = y;
              }
              if (bound.left === null) {
                bound.left = x;
              } else if (x < bound.left) {
                bound.left = x;
              }
              if (bound.right === null) {
                bound.right = x;
              } else if (bound.right < x) {
                bound.right = x;
              }
              if (bound.bottom === null) {
                bound.bottom = y;
              } else if (bound.bottom < y) {
                bound.bottom = y;
              }
            }
            i += 4;
          }
          trimHeight = bound.bottom - bound.top;
          trimWidth = bound.right - bound.left;
          trimmed = ctx.getImageData(bound.left, bound.top, trimWidth, trimHeight);
          copy.canvas.width = trimWidth;
          copy.canvas.height = trimHeight;
          copy.putImageData(trimmed, 0, 0);
          return copy.canvas;
        };

        PrivateStage.prototype.crop = function() {
          var $modeTitle, $toolToggle, brushController, brushMinus, brushPlus, clearBtn, composed, composedWrapper, cropBtn, croppperResize, extractCanvas, extractContext, extractDimensions, isPreview, j, len, modeSwitcher, obj, readyBtn, ref, renderer, undoBtn;
          $toolToggle = $("#" + window.PlayNintendo.CONST.APP_NAMESPACE + "_interface_crop .crop-edits-toggle");
          this.containerCardPhotoWrapper.alpha = 1;
          this.containerCardPhotoWrapper.mask = this.photoMask;
          renderer = new PIXI.CanvasRenderer(this.stageWidth, this.stageHeight, {
            transparent: true
          });
          renderer.render(this.containerCardPhotoWrapper);
          extractCanvas = document.createElement('canvas');
          extractCanvas.width = this.photoMaxSize.x;
          extractCanvas.height = this.photoMaxSize.y;
          extractContext = extractCanvas.getContext('2d');
          extractDimensions = {
            x: this.photoBorder.x < 0 ? 0 : this.photoBorder.x,
            y: this.photoBorder.y < 0 ? 0 : this.photoBorder.y,
            w: this.photoMaxSize.x,
            h: this.photoMaxSize.y
          };
          extractContext.drawImage(renderer.view, extractDimensions.x, extractDimensions.y, extractDimensions.w, extractDimensions.h, 0, 0, extractDimensions.w, extractDimensions.h);
          this.containerCardPhoto.addChild(this.containerCardPhotoWrapper);
          ref = this.containerCardPhotoWrapper.children;
          for (j = 0, len = ref.length; j < len; j++) {
            obj = ref[j];
            this.containerCardPhotoWrapper.removeChild(obj);
          }
          composedWrapper = new PIXI.Container();
          composedWrapper.interactive = true;
          this.containerCardPhotoWrapper.addChild(composedWrapper);
          composed = new PIXI.Sprite(PIXI.Texture.fromCanvas(extractCanvas, PIXI.settings.SCALE_MODE.DEFAULT));
          composedWrapper.addChild(composed);
          composedWrapper.position = {
            x: this.photoBorder.x,
            y: this.photoBorder.y
          };
          if (!this.cropperDiv) {
            this.cropperDiv = document.createElement('div');
            this.cropperDiv.className = 'cropper-container';
            this.cropperDiv.style.position = 'absolute';
          } else {
            this.cropperDiv.style.display = 'block';
          }
          this.cropper = new NS.Cropper(extractCanvas, this.cropperDiv, {
            autofill: false,
            brush: {
              max: (NS.parent.CONST.ISMOBILE ? 48 : 60)
            }
          });
          this.cropper.canvas.style.opacity = 0;
          this.cropper.canvas.style.maxWidth = '100%';
          document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_canvas').appendChild(this.cropperDiv);
          croppperResize = (function(_this) {
            return function() {
              var newH, newW;
              newW = _this.photoBorder.width * _this.viewportWidth / _this.stageWidth;
              newH = _this.photoBorder.height * _this.viewportHeight / _this.stageHeight;
              _this.cropperDiv.style.top = (_this.photoBorder.y * _this.viewportHeight / _this.stageHeight) + 'px';
              _this.cropperDiv.style.left = (_this.photoBorder.x * _this.viewportWidth / _this.stageWidth) + 'px';
              _this.cropperDiv.style.width = newW + 'px';
              _this.cropperDiv.style.height = newH + 'px';
              return _this.cropperDiv.style.zIndex = 1;
            };
          })(this);
          croppperResize();
          window.addEventListener('resize', croppperResize);
          this.cropperHighlight = new PIXI.Sprite(PIXI.Texture.fromCanvas(this.cropper.canvas, PIXI.settings.SCALE_MODE.DEFAULT));
          this.cropperHighlight.alpha = 0.5;
          this.cropperHighlight.position = {
            x: composedWrapper.x,
            y: composedWrapper.y
          };
          this.containerCardPhotoWrapper.addChild(this.cropperHighlight);
          cropBtn = document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_crop-preview');
          brushController = document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_crop-brush');
          brushPlus = document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_crop-plus');
          brushMinus = document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_crop-minus');
          modeSwitcher = document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_crop-mode');
          $modeTitle = $('#' + window.PlayNintendo.CONST.APP_NAMESPACE + '_interface_crop .crop-edits-mode h4');
          undoBtn = document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_crop-undo');
          clearBtn = document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_crop-clear');
          readyBtn = document.getElementById(window.PlayNintendo.CONST.APP_NAMESPACE + '_crop-ready');
          this.cropper.canvas.addEventListener('pointermove', (function(_this) {
            return function() {
              return _this.cropperHighlight.texture.update();
            };
          })(this));
          brushPlus.addEventListener('click', (function(_this) {
            return function() {
              var newSize;
              newSize = _this.cropper.handleBrushChange(true);
              if (newSize + 5 >= 60) {
                brushPlus.classList.add('is-disabled');
              } else {
                brushPlus.classList.remove('is-disabled');
              }
              brushController.style.width = newSize + 'px';
              return brushController.style.height = newSize + 'px';
            };
          })(this));
          brushMinus.addEventListener('click', (function(_this) {
            return function() {
              var newSize;
              newSize = _this.cropper.handleBrushChange(false);
              if (newSize - 5 <= 10) {
                brushMinus.classList.add('is-disabled');
              } else {
                brushMinus.classList.remove('is-disabled');
              }
              brushController.style.width = newSize + 'px';
              return brushController.style.height = newSize + 'px';
            };
          })(this));
          undoBtn.addEventListener('click', (function(_this) {
            return function() {
              _this.cropper.handleUndoClick();
              return _this.cropperHighlight.texture.update();
            };
          })(this));
          clearBtn.addEventListener('click', (function(_this) {
            return function() {
              _this.cropper.handleClearClick();
              return _this.cropperHighlight.texture.update();
            };
          })(this));
          modeSwitcher.addEventListener('change', (function(_this) {
            return function() {
              var mode;
              mode = _this.cropper.handleModeChange();
              return $modeTitle.html('Mode - ' + mode);
            };
          })(this));
          isPreview = false;
          cropBtn.addEventListener('click', (function(_this) {
            return function() {
              var $span, cropped;
              $span = $('span', cropBtn);
              if (!isPreview) {
                cropped = _this.cropper.handleCropClick();
                composedWrapper.removeChild(composed);
                composed = new PIXI.Sprite(PIXI.Texture.fromCanvas(cropped, PIXI.settings.SCALE_MODE.DEFAULT));
                composedWrapper.addChild(composed);
                _this.cropperHighlight.visible = false;
                isPreview = true;
                _this.containerCardPhotoWrapper.alpha = 1;
                $toolToggle.addClass('is-disabled');
                _this.cropper.canvas.style.display = 'none';
                _this.cropper.brushDisplay.style.display = 'none';
                return _this.trackOmnitureLink(39, 'Mario Card Yourself - paint mode - preview', 53, 'Preview toggle');
              } else {
                composedWrapper.removeChild(composed);
                composed = new PIXI.Sprite(PIXI.Texture.fromCanvas(extractCanvas, PIXI.settings.SCALE_MODE.DEFAULT));
                composedWrapper.addChild(composed);
                _this.cropperHighlight.visible = true;
                isPreview = false;
                $toolToggle.removeClass('is-disabled');
                _this.cropper.canvas.style.display = 'block';
                return _this.cropper.brushDisplay.style.display = 'block';
              }
            };
          })(this));
          return readyBtn.addEventListener('click', (function(_this) {
            return function() {
              var cardCanvas, cropped, sprite, stage;
              _this.containerCardPhotoWrapper.alpha = 1;
              $toolToggle.removeClass('is-disabled');
              _this.cropperHighlight.visible = false;
              _this.photoBorder.visible = false;
              _this.containerCardPhoto.addChild(_this.photoBorder);
              cropped = _this.cropper.handleCropClick();
              composedWrapper.removeChild(composed);
              composed = new PIXI.Sprite(PIXI.Texture.fromCanvas(cropped, PIXI.settings.SCALE_MODE.DEFAULT));
              composedWrapper.addChild(composed);
              _this.cropper.destroy();
              _this.cropper = null;
              window.removeEventListener('resize', croppperResize);
              _this.containerCardPhotoWrapper.removeChild(_this.cropperHighlight);
              _this.cropperHighlight = null;
              _this.cropperDiv.style.display = 'none';
              renderer = new PIXI.CanvasRenderer(_this.stageWidth, _this.stageHeight, {
                transparent: true
              });
              stage = new PIXI.Container();
              stage.addChild(_this.containerCard);
              renderer.render(stage);
              cardCanvas = _this.trim(renderer.view);
              sprite = new NS.parent.parent.PIXIApplication.Sticker(PIXI.Texture.fromCanvas(cardCanvas, PIXI.settings.SCALE_MODE.DEFAULT), true);
              _this.containerCard.visible = false;
              _this.glueSticker(sprite, {
                x: _this.stageWidth / 2,
                y: _this.stageHeight / 2
              });
              return _this.containerCardWrapper.addChild(_this.containerCard);
            };
          })(this));
        };


        /*
          private setupVideoCapture
          -------------------------
          Set up the video capture so that we can record the camera and allow
          the user to take a photo
         */

        PrivateStage.prototype.setupVideoCapture = function() {
          this.containerCardPhoto.interactive = false;
          this.onSpriteMouseOut();
          this.zoomLevel = 0;
          this.fixedImageWidth = null;
          this.video = document.createElement('video');
          if (NS.parent.CONST.HASCAMERA && NS.parent.localMediaStream) {
            if ("srcObject" in this.video) {
              this.video.srcObject = NS.parent.localMediaStream;
            } else {
              this.video.src = window.URL.createObjectURL(NS.parent.localMediaStream);
            }
            this.video.addEventListener('canplaythrough', (function(e) {
              this.webcamPlaying = true;
              return setTimeout((function(_this) {
                return function() {
                  return _this.addPhotoGroup();
                };
              })(this), 1000);
            }).bind(this));
            this.video.play();
          }
        };


        /*
          private takePhoto
          -------------------------
          Take the photo based on either camera of image upload.
         */

        PrivateStage.prototype.takePhoto = function() {
          var j, len, obj, ref, renderTexture;
          this.containerCardPhoto.interactive = false;
          this.onSpriteMouseOut();
          this.video = null;
          renderTexture = PIXI.RenderTexture.create(1200, 735);
          this.renderer.render(this.containerCardPhotoWrapper, renderTexture);
          ref = this.containerCardPhotoWrapper;
          for (j = 0, len = ref.length; j < len; j++) {
            obj = ref[j];
            this.containerCardPhotoWrapper.removeChild(obj);
          }
          this.photoSprite = new PIXI.Sprite(renderTexture);
          this.containerCardPhotoWrapper.addChild(this.photoSprite);
        };


        /*
          private fixPhotoDimensions
          -------------------------
          Fix the dimensions of the photo based mainly on width and height, but also,
          optionally on other provided parameters, like flip, which corrects the
          flipping of the camera.
          __Properties__
          - *int* __w__ The width of the photo
          - *int* __h__ The height of the photo
          - *boolean* __flip__ Whether to flip the photo horizontally
          - *int* __targetW__ The target width, the size of the photo to be displayed at by default
         */

        PrivateStage.prototype.fixPhotoDimensions = function(w, h, flip, zoomLevel, targetW, targetH) {
          var newH, newW, ratio, targetRatio;
          if (flip == null) {
            flip = false;
          }
          if (zoomLevel == null) {
            zoomLevel = false;
          }
          if (targetW == null) {
            targetW = this.photoMaxSize.x;
          }
          if (targetH == null) {
            targetH = this.photoMaxSize.y;
          }
          ratio = w / h;
          targetRatio = targetW / targetH;
          if (typeof zoomLevel === 'number') {
            targetW = this.fixedImageWidth + zoomLevel * 50;
            targetH = targetW * targetRatio;
          }
          newH = targetH;
          newW = newH * ratio;
          if (newH > 0) {
            this.photoSprite.width = flip ? newW * -1 : newW;
            this.photoSprite.height = newH;
            return {
              width: newW,
              height: newH
            };
          } else {
            return false;
          }
        };


        /*
          private dropSticker
          -------------------------
          Callback for when a sticker is dropped onto the stage. Adds the sticker and positions it.
          __Properties__
          - *object* __position__ A canvas element representing the uploaded photo
          - *object* __$t__ The target, represented as a jQuery element
         */

        PrivateStage.prototype.dropSticker = function(position, $t) {
          var adjustedCanvasPosition, adjustedGlobalPosition, index, indexParts, offset;
          if (!$t) {
            return;
          }
          offset = $(this.canvas).offset();
          adjustedGlobalPosition = {
            x: position.x - offset.left + window.scrollX,
            y: position.y - offset.top + window.scrollY
          };
          adjustedCanvasPosition = {
            x: adjustedGlobalPosition.x / this.viewportScaleFactor,
            y: adjustedGlobalPosition.y / this.viewportScaleFactor
          };
          indexParts = /button_sticker_([0-9]+)/.exec($t[0].className);
          index = indexParts[1];
          this.addSticker(index, adjustedCanvasPosition);
        };

        PrivateStage.prototype.changeBorder = function(i) {
          var borderImg;
          if (NS.parent.CONST.ISMOBILE) {
            return;
          }
          if (this.containerSceneBorder.children.length > 0) {
            this.containerSceneBorder.removeChild(this.containerSceneBorder.children[0]);
          }
          borderImg = new PIXI.Sprite(PIXI.loader.resources['border_' + i].texture);
          return this.containerSceneBorder.addChild(borderImg);
        };


        /*
          private addSticker
          -------------------------
          Add teh sticker to the stage based on the array index of the sticker and, optionally, a position on stage
          __Properties__
          - *int* __i__ The array index of the sticker to add to stage
          - *object* __position__ The position of the sticker on stage
         */

        PrivateStage.prototype.addSticker = function(i, position) {
          var sprite, texture;
          if (position == null) {
            position = null;
          }
          if (position === null || typeof position !== 'object' || position.x === void 0 || position.y === void 0) {
            position = {
              x: NS.parent.CONST.CANVASDIMENSIONS.WIDTH / 2,
              y: NS.parent.CONST.CANVASDIMENSIONS.HEIGHT / 2
            };
          }
          texture = PIXI.loader.resources['item_' + i].texture;
          sprite = new NS.parent.parent.PIXIApplication.Sticker(texture);
          return this.glueSticker(sprite, position);
        };

        PrivateStage.prototype.glueSticker = function(sprite, position, container) {
          var onUpdateSprite, tween, tweener;
          if (container == null) {
            container = this.containerSceneForground;
          }
          if (!sprite) {
            return;
          }
          if (NS.parent.CONST.ISMOBILE) {
            sprite.buttonScale = 1;
          }
          sprite.init();
          sprite.position.x = position.x;
          sprite.position.y = position.y;
          sprite.alpha = 0;
          sprite.scale.x = sprite.scale.y = 0;
          tweener = {
            alpha: 0,
            scale: 0.1
          };
          onUpdateSprite = (function() {
            sprite.alpha = tweener.alpha;
            sprite.scale.x = tweener.scale;
            return sprite.scale.y = tweener.scale;
          }).bind(this);
          tween = TweenLite.to(tweener, 0.4, {
            alpha: 1,
            scale: 1,
            onUpdate: onUpdateSprite,
            ease: Power2.easeOut
          });
          setTimeout(function() {
            return sprite.focus();
          }, 0);
          setTimeout(function() {
            return sprite.focus();
          }, 100);
          return container.addChild(sprite);
        };

        PrivateStage.prototype.setupImageDownload = function() {
          var logo_console, logo_game;
          logo_game = new PIXI.Sprite(PIXI.loader.resources['asset_logo_game'].texture);
          logo_game.position.x = NS.parent.CONST.ISMOBILE ? 20 : 40;
          logo_game.position.y = NS.parent.CONST.ISMOBILE ? this.stageHeight - 140 : this.stageHeight - 111;
          logo_console = new PIXI.Sprite(PIXI.loader.resources['asset_logo_console'].texture);
          logo_console.position.x = this.stageWidth - logo_console.width;
          logo_console.position.y = 0;
          this.containerSceneLogos.addChild(logo_game);
          this.containerSceneLogos.addChild(logo_console);
          this.setupDownload();
        };

        PrivateStage.prototype.cleanupImageDownload = function() {
          while (this.containerSceneLogos.children[0]) {
            this.containerSceneLogos.removeChild(this.containerSceneLogos.children[0]);
          }
        };

        PrivateStage.prototype.setupDownload = function() {
          var extractCanvas, extractContext, renderer;
          this.stopRender();
          renderer = new PIXI.CanvasRenderer(this.stageWidth, this.stageHeight, {
            transparent: true
          });
          renderer.render(this.stage);
          extractCanvas = document.createElement('canvas');
          extractCanvas.width = this.stageWidth;
          extractCanvas.height = this.stageHeight;
          extractContext = extractCanvas.getContext('2d');
          extractContext.drawImage(renderer.view, 0, 0, this.stageWidth, this.stageHeight, 0, 0, this.stageWidth, this.stageHeight);
          setTimeout((function() {
            var imageData, img;
            imageData = extractCanvas.toDataURL();
            NS.Model.setData('outputImage', imageData);
            img = document.createElement('img');
            img.src = imageData;
            return $(window).trigger('stage:generated', [this, imageData]);
          }).bind(this), 300);
          renderer.destroy();
          this.startRender();
        };


        /* EVENT LISTENERS */

        PrivateStage.prototype.onSpriteMouseDown = function(e) {
          this.spriteMouseDown = true;
          this.mousePositionStart = e.data.getLocalPosition(this.photoSprite.parent);
          this.offset = {
            x: this.photoSprite.position.x - this.mousePositionStart.x,
            y: this.photoSprite.position.y - this.mousePositionStart.y
          };
        };

        PrivateStage.prototype.onSpriteMouseMove = function(e) {
          var mousePosition;
          if (this.spriteMouseDown === true) {
            mousePosition = e.data.getLocalPosition(this.photoSprite.parent);
            this.positionPhotoGroup(mousePosition.x + this.offset.x, mousePosition.y + this.offset.y);
          }
        };

        PrivateStage.prototype.onSpriteMouseUp = function(e) {
          this.spriteMouseDown = false;
        };

        PrivateStage.prototype.onSpriteMouseOver = function(e) {
          $('body').css('cursor', 'all-scroll');
        };

        PrivateStage.prototype.onSpriteMouseOut = function(e) {
          $('body').css('cursor', 'default');
          this.spriteMouseDown = false;
        };

        PrivateStage.prototype.trackOmnitureLink = function(eVar, eVarData, events, name) {
          var e;
          try {
            window.OMNITRACK(eVar, eVarData, events, name);
          } catch (error) {
            e = error;
            console.log(e);
          }
        };

        return PrivateStage;

      })();

      Stage.init = function(w, h, s) {
        if (w == null) {
          w = null;
        }
        if (h == null) {
          h = null;
        }
        if (s == null) {
          s = 1;
        }
        if (w === null || typeof w !== 'number' || h === null || typeof h !== 'number') {
          w = NS.parent.CONST.CANVASDIMENSIONS.WIDTH;
          h = NS.parent.CONST.CANVASDIMENSIONS.HEIGHT;
        }
        instance = new PrivateStage(w, h, s);
        instance.reset(w, h, s);
        return instance;
      };

      Stage.get = function(reset) {
        var h, w;
        if (reset == null) {
          reset = false;
        }
        if (!instance) {
          return this.init();
        } else if (reset) {
          w = NS.parent.CONST.CANVASDIMENSIONS.WIDTH;
          h = NS.parent.CONST.CANVASDIMENSIONS.HEIGHT;
          return instance.reset(w, h, 1);
        } else {
          instance.addToDOM();
          return instance;
        }
      };

      return Stage;

    })();
  })(window[appNS].Nintendo.Game.Application);

}).call(this);


/*

  =======================================
  - 
  - 
  - *Created*         2016-03-07 13:38:38
  - *namespace*       .
  - *Requirements*    jQuery
  - *Description*     .
  - 
  - *Edited*          2016-05-17 11:09:06
  - *Version*         0.1
 */

(function() {
  "use strict";
  var appNS, base;

  appNS = window.PlayNintendo.CONST.APP_NAMESPACE;

  window[appNS] || (window[appNS] = {});

  (base = window[appNS]).Nintendo || (base.Nintendo = {});

  (function(NS) {
    var camPromise, i, imageID, imgPreloader, interval, j, kingdom, l, len, loader, m, num, obj, path, ref, ref1, ref2, ref3;
    NS.templates = window.GameApplication.templates;
    if (Modernizr.touchevents) {
      NS.CONST.ISTOUCH = true;
    } else {
      NS.CONST.ISTOUCH = false;
    }
    if (Modernizr.getusermedia) {
      NS.CONST.HASCAMERA = true;
      camPromise = navigator.mediaDevices.getUserMedia({
        video: {
          facingMode: "user"
        },
        audio: false
      }).then(function(stream) {
        if (stream.getVideoTracks().length === 0) {
          NS.CONST.HASCAMERA = false;
          NS.localMediaStream = false;
        } else {
          NS.localMediaStream = stream;
        }
        return NS.CONST.HASCAMERA;
      })["catch"](function(err) {
        console.log('Webcam ' + err.name + ": " + err.message);
        NS.CONST.HASCAMERA = false;
        NS.localMediaStream = false;
        return NS.CONST.HASCAMERA;
      });
    } else {
      NS.CONST.HASCAMERA = false;
    }
    PIXI.utils._saidHello = true;
    NS.assetsLoaded = {
      pixi: false,
      app: false
    };

    /**
     * Simple sequential preloader
     * Sequential because then we can also start preloading the pixi assets and not
     * clog the browser parallel connections with only the global assets
     */
    imgPreloader = function(options, index) {
      var img;
      if (options == null) {
        options = {
          images: null,
          callback: null
        };
      }
      if (index == null) {
        index = 0;
      }
      if (options.images && options.images.length > index) {
        img = new Image();
        img.onload = function() {
          return imgPreloader(options, index + 1);
        };
        img.src = window.PlayNintendo.CONST.APP_ROOT_PATH + "assets/img/" + options.images[index];
      } else if (index >= options.images.length && options.callback) {
        options.callback();
      }
    };
    imgPreloader({
      images: NS.CONST.APPASSETS,
      callback: function() {
        return NS.assetsLoaded.app = true;
      }
    });
    loader = PIXI.loader;
    ref = NS.CONST.ASSETS;
    for (m in ref) {
      obj = ref[m];
      imageID = 'asset_' + m;
      loader.add(imageID, NS.CONST.PATH_ASSETS + obj);
    }
    ref1 = NS.CONST.KINGDOMS;
    for (i = 0, len = ref1.length; i < len; i++) {
      kingdom = ref1[i];
      imageID = 'kingdom-' + kingdom + '_fg';
      loader.add(imageID, NS.CONST.PATH_ASSETS + 'foregrounds/fg-' + kingdom + '.png');
      imageID = 'kingdom-' + kingdom;
      loader.add(imageID, NS.CONST.PATH_ASSETS + 'backgrounds/bg-' + kingdom + '.jpg');
    }
    for (num = j = 1, ref2 = NS.CONST.STICKERS; 1 <= ref2 ? j <= ref2 : j >= ref2; num = 1 <= ref2 ? ++j : --j) {
      imageID = 'item_' + num;
      loader.add(imageID, NS.CONST.PATH_ASSETS + 'items/item-' + num + '.png');
    }
    for (num = l = 1, ref3 = NS.CONST.BORDERS; 1 <= ref3 ? l <= ref3 : l >= ref3; num = 1 <= ref3 ? ++l : --l) {
      path = 'borders/border' + num + '.png';
      imageID = 'border_' + num;
      loader.add(imageID, NS.CONST.PATH_ASSETS + path);
    }
    loader.once('complete', function(loader, resources) {
      NS.assetsLoaded.pixi = true;
      NS.parent.PIXIApplication.Sticker.deleteButtonTexture = PIXI.loader.resources.asset_button_delete.texture;
      return NS.parent.PIXIApplication.Sticker.resizeButtonTexture = PIXI.loader.resources.asset_button_resize.texture;
    });
    loader.load();
    window.loader = loader;
    return interval = setInterval(function() {
      var all, k, ref4, v;
      all = true;
      ref4 = NS.assetsLoaded;
      for (k in ref4) {
        v = ref4[k];
        if (v === false) {
          all = false;
        }
        break;
      }
      if (all === true) {
        window[appNS].Nintendo.Game.Application.init();
        return clearInterval(interval);
      }
    }, 500);
  })(window[appNS].Nintendo.Game);

}).call(this);
